SystemOrganization addCategory: #'SqSync-Shared'!
SystemOrganization addCategory: #'SqSync-Client'!
SystemOrganization addCategory: #'SqSync-Server'!
SystemOrganization addCategory: #'SqSync-Repository'!
SystemOrganization addCategory: #'SqSync-Tools'!
SystemOrganization addCategory: #'SqSync-AddressBook'!
SystemOrganization addCategory: #'SqSync-AddressBook-Test'!
SystemOrganization addCategory: #'SqSync-Tests'!
SystemOrganization addCategory: #SqSync!

!UndefinedObject methodsFor: '*SqSync' stamp: 'rkrk 6/13/2010 23:38:22.564'!
isNilOrTerminated

	^ true! !

Model subclass: #SyAddressBook
	instanceVariableNames: 'persons personListIndex client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-AddressBook'!

!SyAddressBook class methodsFor: 'demo' stamp: 'mt 6/22/2010 18:53:12.827'!
addDemoDataTo: aSyServer

	| personList |
	personList := PersonList new.
	aSyServer repository rootObject: personList.
	
	aSyServer repository register: (personList addPerson: (Person givenName: 'Bastian' surname: 'Steinert')).
	aSyServer repository register: (personList addPerson: (Person givenName: 'Malte' surname: 'Appeltauer')).
	aSyServer repository register: (personList addPerson: (Person givenName: 'Michael' surname: 'Perscheid')).
	
	personList persons first address: 'Berlin'.
	personList persons second address: 'Berlin'.
	personList persons third address: 'Potsdam'.
	
		.! !

!SyAddressBook class methodsFor: 'opening' stamp: 'rkrk 6/20/2010 15:44:31.441'!
open

	self new open! !

!SyAddressBook class methodsFor: 'demo' stamp: 'mt 6/22/2010 18:42:04.278'!
openClient

	| instance window |
	instance := self new.
	instance connectToHostNamed: 'localhost' port: 22701.
	window := instance open.
	^ window	.! !

!SyAddressBook class methodsFor: 'demo' stamp: 'mt 6/22/2010 18:51:02.293'!
openDemo

	| srv |
	srv := SyServer new start.
	
	self addDemoDataTo: srv.
	
	self openClient topLeft: 0@0.
	self openClient topLeft: 500@0.
	
	srv explore. "Close server manually."
	
	
		.! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 01:16:29.412'!
addFriend

	| person friend |
	person := self selectedPerson.
	person ifNil: [^self].
	friend := self requestPerson.
	friend ifNil: [
		self inform: 'Cannot find this person in address book!!'.
		^self].
	friend == person ifTrue: [
		self inform: 'Cannot add a person as her/his own friend'.
		^self].
	person addFriend: friend.
	self changed: #personDetails.! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/20/2010 15:39:52.407'!
addPerson

	| givenName lastName |
	givenName := self request: 'Please enter given name' initialAnswer: ''.
	lastName := self request: 'Please enter last name' initialAnswer: ''.
	(lastName isEmpty or: [givenName isEmpty]) ifTrue: [^self].
	self createAndAddPerson: givenName lastName: lastName.
	self changed: #personList.! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'mt 6/22/2010 18:35:18.696'!
buildButtonsWith: builder
			
	| panelSpec buttonSpec addButtonNo addButtonFrames editButtonNo editButtonFrames incr defaultRect |
	panelSpec := builder pluggablePanelSpec new.
	panelSpec children: OrderedCollection new.

	addButtonNo := 2.
	incr := 0.5 / addButtonNo.
	defaultRect := 0@0 corner: incr@1.
	addButtonFrames := (0 to: addButtonNo-1) collect: [:i | defaultRect translateBy: i*incr@0].

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'Refresh'; 
			state: nil;
			action: #refresh;
			frame: (addButtonFrames at: 1).
	panelSpec children addLast: buttonSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'add person'; 
			state: #canAddPerson;
			action: #addPerson;
			frame: (addButtonFrames at: 2).
	panelSpec children addLast: buttonSpec.

	editButtonNo := 3.
	incr := 0.5 / editButtonNo.
	defaultRect := 0.5@0 corner: 0.5+incr@1.
	editButtonFrames := (0 to: editButtonNo-1) collect: [:i | defaultRect translateBy: i*incr@0].
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'edit address';
			state: #canEditAddress;
			action: #editAddress;
			frame: (editButtonFrames at: 1).
	panelSpec children addLast: buttonSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'edit birthday';
			state: #canEditBirthday;
			action: #editBirthday;
			frame: (editButtonFrames at: 2).
	panelSpec children addLast: buttonSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'add friend';
			state: #canAddFriend;
			action: #addFriend;
			frame: (editButtonFrames at: 3).
	panelSpec children addLast: buttonSpec.
	
	^panelSpec! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'rkrk 6/20/2010 15:18:50.737'!
buildPersonDetailsWith: builder

	| textSpec |
	textSpec := builder pluggableTextSpec new.
	textSpec 
		model: self;
		getText: #personDetails.
		"setText: #contents:notifying:;
		selection: #contentsSelection; 
		menu: #codePaneMenu:shifted:."
	^textSpec! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'rkrk 6/20/2010 15:08:38.91'!
buildPersonListWith: builder

	| listSpec |
	listSpec := builder pluggableListSpec new.
	listSpec 
		model: self;
		list: #personList;
		getIndex: #personListIndex;
		setIndex: #personListIndex:.
		"menu: #classListMenu:shifted:; "
		"keyPress: #classListKey:from:."
	^listSpec
! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'mt 6/22/2010 16:48:59.013'!
buildWindowWith: builder

	"copied from StringHolder"
	| windowSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: #labelString.
	windowSpec children: OrderedCollection new.
	windowSpec closeAction: #close.
	^windowSpec! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'rkrk 6/20/2010 14:58:34.483'!
buildWindowWith: builder specs: specs

	"copied from StringHolder"
	| windowSpec |
	windowSpec := self buildWindowWith: builder.
	specs do:[:assoc|
		| rect action widgetSpec |
		rect := assoc key.
		action := assoc value.
		widgetSpec := action value.
		widgetSpec ifNotNil:[
			widgetSpec frame: rect.
			windowSpec children add: widgetSpec]].
	^windowSpec! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'rkrk 6/20/2010 15:15:48.429'!
buildWith: builder

	^ self buildWindowWith: builder specs: {
			(0@0 corner: 0.5@0.9) -> [self buildPersonListWith: builder].
			(0@0.9 corner: 1@1) -> [self buildButtonsWith: builder].
			(0.5@0 corner: 1@0.9) -> [self buildPersonDetailsWith: builder].
			"(0.34@0.06 corner: 0.67@0.34) -> [self buildMessageCategoryListWith: builder].
			(0.67@0.06 corner: 1.0@0.34) -> [self buildMessageListWith: builder].
			(0.0@0.34 corner: 1.0@0.9) -> [self buildCodePaneWith: builder].
			(0.0@0.9 corner: 1.0@1.0) -> [self buildInfoViewWith: builder]"
			}! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:55:00.52'!
canAddFriend

	^ self selectedPerson notNil! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/20/2010 15:12:29.418'!
canAddPerson

	^ true! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:17:11.801'!
canEditAddress

	^ self selectedPerson notNil! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:54:54.548'!
canEditBirthday

	^ self selectedPerson notNil! !

!SyAddressBook methodsFor: 'SqSync' stamp: 'mt 6/22/2010 17:10:32.528'!
close
	"Callback when window is closed."
	
	client ifNotNil: [:c | c disconnect.].
	Transcript cr; show: 'AddressBook client closed successfully.'.! !

!SyAddressBook methodsFor: 'SqSync' stamp: 'mt 6/22/2010 17:34:55.386'!
connectToHostNamed: aHost port: aPort

	client ifNotNil: [:c | c disconnect].
	client := SyClient new.
	client connectToHostNamed: aHost port: aPort.
	
	self changed: #personList.! !

!SyAddressBook methodsFor: 'address book functionality' stamp: 'mt 6/22/2010 17:33:50.398'!
createAndAddPerson: givenName lastName: lastName

	| p |
	p := Person givenName: givenName surname: lastName.
	
	client
		ifNil: [self persons add: p]
		ifNotNil: [client repository rootObject addPerson: p].! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:36:06.042'!
editAddress

	| person address |
	person := self selectedPerson.
	person ifNil: [^self].
	address := person address.
	(address isNil or: [address isString]) ifTrue: [address := SyAddress new].
	person address: (self requestAddressUsing: address).
	self changed: #personDetails.! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 01:02:49.206'!
editBirthday

	| person birthday |
	person := self selectedPerson.
	person ifNil: [^self].
	birthday := person birthday.
	(birthday isNil or: [birthday isString]) ifTrue: [birthday := Date today].
	person birthday: (self requestBirthdayUsing: birthday).
	self changed: #personDetails.! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/20/2010 14:59:20.247'!
labelString
	^self class name! !

!SyAddressBook methodsFor: 'toolbuilder' stamp: 'mt 6/22/2010 18:37:35.192'!
open

	| builder |
	builder := ToolBuilder default.
	^ (builder open: (self buildWith: builder)) extent: 500@250.! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:13:32.297'!
personDetails

	self selectedPerson ifNil: [^ ''].
	^ String streamContents: [:stream |
		stream
			print: self selectedPerson; cr; cr;
			nextPutAll: 'Address:'; cr; print: self selectedPerson address; cr; cr;
			nextPutAll: 'Birthday:'; cr; print: self selectedPerson birthday; cr; cr;
			nextPutAll: 'Friends:'; cr; nextPutAll: self selectedPerson friends asCommaString].! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/20/2010 15:39:20.517'!
personList

	^ self persons! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/20/2010 15:45:09.007'!
personListIndex

	^ personListIndex ifNil: [personListIndex := 0]! !

!SyAddressBook methodsFor: 'toolbuilder-callbacks' stamp: 'rkrk 6/21/2010 00:08:59.214'!
personListIndex: index

	personListIndex := index.
	self changed: #personListIndex.
	self changed: #personDetails.! !

!SyAddressBook methodsFor: 'accessing' stamp: 'mt 6/22/2010 17:31:53.619'!
persons

	^ client
		ifNil: [persons ifNil: [persons := OrderedCollection new]]
		ifNotNil: [client repository rootObject persons].! !

!SyAddressBook methodsFor: 'SqSync' stamp: 'mt 6/22/2010 18:29:20.784'!
refresh

	self changed: #personList.
	self changed: #personDetails.! !

!SyAddressBook methodsFor: 'ui support' stamp: 'rkrk 6/20/2010 15:29:26.052'!
request: question initialAnswer: string

	^ UIManager default request: question initialAnswer: string.! !

!SyAddressBook methodsFor: 'address book functionality' stamp: 'rkrk 6/21/2010 00:34:37.066'!
requestAddressUsing: existingAddress

	| street streetNo postalCode town |
	street := self request: 'Enter streetname' initialAnswer: existingAddress street.
	streetNo := self request: 'Enter house number' initialAnswer: existingAddress streetNo.
	postalCode := self request: 'Enter postal code' initialAnswer: existingAddress postalCode.
	town := self request: 'Enter town' initialAnswer: existingAddress town.
	"Reuse old address? Then it wouldn't be a value object..."
	^ SyAddress
		street: street
		streetNo: streetNo
		postalCode: postalCode
		town: town.! !

!SyAddressBook methodsFor: 'address book functionality' stamp: 'rkrk 6/21/2010 00:44:30.391'!
requestBirthdayUsing: birthday

	| string |
	string := self request: 'Enter birthday as DD MM YYYY' initialAnswer: birthday asString.
	^ [Date readFrom: string readStream] on: Error do: [birthday].! !

!SyAddressBook methodsFor: 'address book functionality' stamp: 'rkrk 6/21/2010 01:12:42.242'!
requestPerson

	| name |
	name := self request: 'Enter first and last name of person' initialAnswer: ''.
	^ self persons
		detect: [:ea | ea asString = name]
		ifNone: [nil].
		! !

!SyAddressBook methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:09:14.441'!
selectedPerson

	^ self persons
		at: self personListIndex
		ifAbsent: [nil].! !

!CompiledMethod methodsFor: '*SqSync' stamp: 'SR 7/11/2010 22:06:31.813'!
hasInstVarStore
	"Answer whether the method references an instance variable."

	| scanner end printer |

	scanner := InstructionStream on: self.
	printer := SyInstVarStoreLocator new.
	end := self endPC.

	[scanner pc <= end] whileTrue: [
		(printer interpretNextInstructionUsing: scanner) ifTrue: [^true].
	].
	^false! !

ReferenceStream subclass: #SyReferenceMappingStream
	instanceVariableNames: 'mapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:19.245'!
mapping: aSyReferenceMapping

	^ self
		on: (RWBinaryOrTextStream on: '')
		mapping: aSyReferenceMapping.! !

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:10.363'!
on: stream	mapping: aSyReferenceMapping
	
	^ (self on: stream)
		mapping: aSyReferenceMapping;
		yourself.! !

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:28.091'!
streamedRepresentationOf: anObject mapping: aSyReferenceMapping
	
	"copied from DataStream class >> #streamedRepresentationOf:"
	| file |
	file := (RWBinaryOrTextStream on: (ByteArray new: 5000)).
	file binary.
	(self on: file mapping: aSyReferenceMapping) nextPut: anObject.
	^file contents! !

!SyReferenceMappingStream class methodsFor: 'as yet unclassified' stamp: 'mt 6/15/2010 15:30:34.12'!
unStream: messageBytes mapping: aSyReferenceMapping

	"copied from DataStream class >> #streamedRepresentationOf:"
	^(self
		on: ((RWBinaryOrTextStream with: messageBytes) reset; binary)
		mapping: aSyReferenceMapping) next! !

!SyReferenceMappingStream methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:28:48.149'!
mapping

	^ mapping ifNil: [mapping := SyReferenceMapping new]! !

!SyReferenceMappingStream methodsFor: 'accessing' stamp: 'mt 6/15/2010 14:59:33.612'!
mapping: aSyReferenceMapping

	mapping := aSyReferenceMapping! !

!SyReferenceMappingStream methodsFor: 'write and read' stamp: 'mt 6/15/2010 15:02:47.878'!
next

	| unconverted |
	unconverted := super next.
	^ self mapping backward value: unconverted.! !

!SyReferenceMappingStream methodsFor: 'write and read' stamp: 'mt 6/15/2010 15:02:57.417'!
nextPut: anObject

	| converted |
	converted := self mapping foreward value: anObject.
	^ super nextPut: converted.! !

Exception subclass: #SyAlreadyRegisteredException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

Exception subclass: #SyApplyCommandRefusedException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

Exception subclass: #SyClientClosedConnectionException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyClientClosedConnectionException commentStamp: 'SR 6/5/2010 19:16:20.123' prior: 0!
Thrown by execute methods if client connection should be closed.!

!Object methodsFor: '*SqSync' stamp: 'SR 6/18/2010 14:46:18.381'!
isSqEntityType

	^ false! !

Object subclass: #SqEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

SqEntity subclass: #Person
	instanceVariableNames: 'givenName surname birthday address friends specialFriend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!Person commentStamp: 'mt 5/19/2010 13:05:53.083' prior: 0!
I am part of the example domain model.!

!Person class methodsFor: 'as yet unclassified' stamp: 'SR 5/15/2010 12:28:45.274'!
givenName: aFirstString surname: aSecondString

	^ (self new)
		givenName: aFirstString;
		surname: aSecondString;
		yourself.! !

!Person methodsFor: 'comparing' stamp: 'rkrk 6/21/2010 00:03:36.08'!
= anObject

	^ self species = anObject species
		and: [self givenName = anObject givenName]
		and: [self surname = anObject surname]
		and: [self birthday = anObject birthday]
		and: [self address = anObject address]! !

!Person methodsFor: 'accessing' stamp: 'mt 6/22/2010 18:27:23.07'!
addFriend: aPerson
	"Bidirectional."
	
	(self friends includes: aPerson) ifTrue: [^ self].
	
	self friends add: aPerson.
	aPerson addFriend: self.! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:08.009'!
address
	^ address! !

!Person methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:01:42.055'!
address: addressOrString

	address := addressOrString! !

!Person methodsFor: 'accessing' stamp: 'mt 6/19/2010 17:07:32.415'!
bidirectionalSpecialFriend: aPerson

	(specialFriend == aPerson) ifTrue: [^ self].

	specialFriend := aPerson.
	aPerson bidirectionalSpecialFriend: self.! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:18.253'!
birthday
	^ birthday! !

!Person methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 01:03:26.544'!
birthday: stringOrDate

	birthday := stringOrDate! !

!Person methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:58:53.508'!
friends

	^ friends! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:24.381'!
givenName
	^ givenName! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:32.385'!
givenName: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	givenName := aString! !

!Person methodsFor: 'initialize-release' stamp: 'SR 6/14/2010 19:46:29.512'!
initialize

	friends := OrderedCollection new.! !

!Person methodsFor: 'as yet unclassified' stamp: 'rkrk 6/20/2010 15:42:14.424'!
printOn: stream

	stream
		nextPutAll: self givenName;
		space;
		nextPutAll: self surname.! !

!Person methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:59:22.951'!
specialFriend

	^ specialFriend! !

!Person methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:59:26.151'!
specialFriend: anObject

	specialFriend := anObject! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:25:32.002'!
surname
	^ surname! !

!Person methodsFor: 'accessing' stamp: 'SR 5/15/2010 12:26:22.555'!
surname: aString

	(aString isString) ifFalse: [Exception signal: 'Invalid data type'].
	surname := aString.! !

SqEntity subclass: #PersonList
	instanceVariableNames: 'persons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!PersonList methodsFor: 'accessing' stamp: 'mt 6/22/2010 18:52:23.944'!
addPerson: aPerson

	persons add: aPerson.
	^ aPerson! !

!PersonList methodsFor: 'initialize-release' stamp: 'SR 6/14/2010 20:03:26.872'!
initialize

	super initialize.
	
	persons := OrderedCollection new.! !

!PersonList methodsFor: 'accessing' stamp: 'SR 6/14/2010 20:03:33.95'!
persons

	^ persons! !

!SqEntity methodsFor: 'testing' stamp: 'SR 6/18/2010 14:46:38.385'!
isSqEntityType

	^ true! !

SqEntity subclass: #SyAddress
	instanceVariableNames: 'street streetNo postalCode town'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyAddress class methodsFor: 'instance creation' stamp: 'rkrk 6/21/2010 00:00:15.949'!
street: street streetNo: streetNo postalCode: postalCode town: town

	^self new
		street: street;
		streetNo: streetNo;
		postalCode: postalCode;
		town: town.! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:37:32.688'!
postalCode
	^ postalCode ifNil: ['']! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/20/2010 23:57:06.039'!
postalCode: anObject
	postalCode := anObject! !

!SyAddress methodsFor: 'printing' stamp: 'rkrk 6/21/2010 00:23:56.739'!
printOn: stream

	stream
		nextPutAll: self street;
		space;
		nextPutAll: self streetNo asString;
		cr;
		nextPutAll: self postalCode;
		space;
		nextPutAll: self town.! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:37:20.482'!
street
	^ street ifNil: ['']! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/20/2010 23:57:06.014'!
street: anObject
	street := anObject! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:37:26.184'!
streetNo
	^ streetNo ifNil: ['']! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/20/2010 23:57:06.026'!
streetNo: anObject
	streetNo := anObject! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/21/2010 00:37:29.894'!
town
	^ town ifNil: ['']! !

!SyAddress methodsFor: 'accessing' stamp: 'rkrk 6/20/2010 23:57:06.051'!
town: anObject
	town := anObject! !

Object subclass: #SyClassInstrumentor
	instanceVariableNames: 'wrappers processor shouldPublishMethodCalls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyClassInstrumentor commentStamp: 'SR 5/20/2010 18:32:53.47' prior: 0!
Used to configure method wrappers:

| instr o1 |
instr := SyClassInstrumentor new.
o1 := Person new.

instr instrumentClass: (o1 class).
o1 givenName: 'test'.
instr uninstrumentAllAndReset.

If not correctly clean up, use: SyMethodWrapper allInstances do: [:mw|mw uninstall]!

!SyClassInstrumentor class methodsFor: 'support' stamp: 'rkrk 6/14/2010 01:21:03.701'!
cleanClass: class

	"self cleanClass: Person"
	self new uninstrumentClass: class.! !

!SyClassInstrumentor methodsFor: 'as yet unclassified' stamp: 'mt 6/19/2010 17:36:34.185'!
initialize 

	super initialize.
	shouldPublishMethodCalls := true.! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 17:59:40.643'!
instrumentClass: aClass

	{aClass. aClass class} do: [:c |
		c selectors do: [:selector |
			self instrumentMethod: selector inClass: c ]].! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 18:01:36.24'!
instrumentMethod: selector inClass: aClass

	(self isMethodInstrumented: selector inClass: aClass) ifFalse: [
		SystemChangeNotifier uniqueInstance doSilently: [
			(self wrappers add:
				(SyMethodWrapper on: selector inClass: aClass for: self))
				install]].! !

!SyClassInstrumentor methodsFor: 'testing' stamp: 'rkrk 6/14/2010 01:02:03.766'!
isMethodInstrumented: selector inClass: aClass

	^ self wrappers anySatisfy: [:wrapper |
		wrapper wrappedClass = aClass and: [wrapper selector = selector]]! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'SR 6/30/2010 11:57:00.586'!
methodCalled: aSelector on: anObject with: anArrayOfObjects hasSideEffect: aBoolean

	self processor ifNil: [^self].
	self processor
		process: aSelector
		on: anObject
		with: anArrayOfObjects
		hasSideEffects: aBoolean! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.324'!
processor
	^ processor! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'SR 5/17/2010 19:48:49.336'!
processor: anObject
	processor := anObject! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'mt 6/19/2010 17:34:39.27'!
shouldPublishMethodCalls
	^ shouldPublishMethodCalls! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'mt 6/19/2010 17:34:39.343'!
shouldPublishMethodCalls: anObject
	shouldPublishMethodCalls := anObject! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 18:04:16.121'!
uninstrumentAllAndReset

	self wrappers do: [:wrapper | wrapper uninstall].
	wrappers := nil.! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 18:06:26.459'!
uninstrumentClass: aClass

	self wrappers
		select: [:wrapper | wrapper wrappedClass = aClass or: [wrapper wrappedClass = aClass class]]
		thenDo: [:wrapper | wrapper uninstall. self wrappers remove: wrapper ifAbsent: ["Weak."]]! !

!SyClassInstrumentor methodsFor: 'instrumenting' stamp: 'mt 6/12/2010 18:08:28.817'!
uninstrumentMethod: aCompiledMethod

	self wrappers
		select: [:wrapper | wrapper clientMethod = aCompiledMethod]
		thenDo: [:wrapper | wrapper uninstall. self wrappers remove: wrapper ifAbsent: ["weak."]].
! !

!SyClassInstrumentor methodsFor: 'accessing' stamp: 'mt 6/12/2010 17:49:25.948'!
wrappers

	^ wrappers ifNil: [wrappers := WeakSet new]! !

Object subclass: #SyClient
	instanceVariableNames: 'socket repository protocolProcessor connectionProcess incomingCommandProcess pendingApplyCommandQueue pendingApplyCommandQueueWorker shouldDeferSends'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Client'!

!SyClient commentStamp: 'mt 6/13/2010 15:24:45.171' prior: 0!
The client has 4 processes at the moment:

- UI process for interactions from workspace
- connection process to incoming network data
- process to handle incoming commands from protocol processor
- process to send apply-commands blocking!

!SyClient methodsFor: 'accessing' stamp: 'rkrk 6/14/2010 01:44:57.148'!
commandsNotYetSend

	^ pendingApplyCommandQueue! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 6/5/2010 19:42:24.879'!
connectToHostNamed: aHost port: aPort

	socket := SyTcpSocket openConnectionToHostNamed: aHost port: aPort.
	self
		startConnectionThread;
		pvtUpdateRepository;
		startIncomingCommandProcess.! !

!SyClient methodsFor: 'debugging' stamp: 'rkrk 6/14/2010 00:28:30.287'!
deferSends

	shouldDeferSends := true.
	self killPendingApplyCommandQueueWorker.! !

!SyClient methodsFor: 'connection-handling' stamp: 'mt 6/13/2010 15:35:02.365'!
disconnect

	"Kill command processing"
	incomingCommandProcess ifNotNilDo: [:proc | proc terminate].

	socket ifNil: [^ self].
	
	"Kill connection"
	connectionProcess terminate.
	protocolProcessor killOutgoingQueueWorker.
	self killPendingApplyCommandQueueWorker.
	socket close.
	
	"Clear method wrapper"
	repository clear.! !

!SyClient methodsFor: 'debugging' stamp: 'rkrk 6/14/2010 00:28:56.379'!
dontDeferSends

	shouldDeferSends := false.
	self pvtCheckPendingApplyCommandQueueWorker.! !

!SyClient methodsFor: 'initialize-release' stamp: 'mt 6/19/2010 14:59:01.165'!
initialize

	super initialize.
	
	repository := SyRepository new
		shouldCreateCommands: true;
		addDependent: self; "for sending commands"
		yourself.
	protocolProcessor := SySimpleProtocolProcessor new
		objectMapping: (SyReferenceMapping foreward: repository forewardReferenceMappingBlock backward: repository backwardReferenceMappingBlock).
	pendingApplyCommandQueue := SharedQueue new.
	shouldDeferSends := false.! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 5/15/2010 14:50:21.163'!
isConnected

	socket ifNil: [ ^ false ].
	^ socket isConnected! !

!SyClient methodsFor: 'command handling' stamp: 'rkrk 6/13/2010 23:38:46.905'!
killPendingApplyCommandQueueWorker

	pendingApplyCommandQueueWorker isNilOrTerminated
		ifFalse: [pendingApplyCommandQueueWorker terminate].! !

!SyClient methodsFor: 'debugging' stamp: 'rkrk 6/2/2010 17:15:54.023'!
log: msg

	Transcript cr; show: msg asString.! !

!SyClient methodsFor: 'accessing' stamp: 'rkrk 6/14/2010 17:08:09.674'!
mapRegisteredObjectsBlock

	^ [:o | o].! !

!SyClient methodsFor: 'command handling' stamp: 'rkrk 6/13/2010 23:35:06.971'!
processIncomingCommands
	"See SySimpleProtocolProcessor>>pvtProcessCommand:senderID: for more infos."
	
	| array command senderStream |
	array := protocolProcessor nextCommand.

	command := array second.
	senderStream := array third.
	
	self log: 'SyClient (' , self identityHash asString , ') processing: ' , command asString.
	
	[command execute: self repository] "Just execute the command. No response expected yet."
		on: SyClientClosedConnectionException
		do: [senderStream close]
		on: SyApplyCommandRefusedException
		do: [Transcript cr; show: 'SyApplyCommand refused for client (', self identityHash asString, ')!!'. self reboot].! !

!SyClient methodsFor: 'command handling' stamp: 'SR 6/14/2010 19:34:23.866'!
pvtCheckPendingApplyCommandQueueWorker

	"Send all apply-commands blocking to verify their execution."
	pendingApplyCommandQueueWorker isNilOrTerminated ifFalse: [^self].
	pendingApplyCommandQueueWorker := [ | command result |
		[(command := pendingApplyCommandQueue nextOrNil) notNil] whileTrue: [
			self log: 'Client (' , self identityHash asString , ') sending: ' , command asString.
			result := protocolProcessor
				sendCommandBlocking: command
				on: socket.
			"Schedule a local command to be processed by the one and only process that accesses the repository."
			protocolProcessor nextCommandPutLocal:
				(SyResultProxyCommand forCommand: result)]] sqFork.! !

!SyClient methodsFor: 'orchestration' stamp: 'SR 6/14/2010 19:34:32.825'!
pvtUpdateRepository

	| command |
	command := protocolProcessor
		sendCommandBlocking: SyListCommand new
		on: socket.
	command executeWithResult: self repository.! !

!SyClient methodsFor: 'initialize-release' stamp: 'mt 6/13/2010 16:32:01.015'!
reboot

	| newClient host port |
	host := socket remoteAddress.
	port := socket remotePort.
	
	self disconnect.
	
	newClient := self class new.
	newClient connectToHostNamed: host port: port.
	
	self becomeForward: newClient.
	! !

!SyClient methodsFor: 'initialize-release' stamp: 'rkrk 6/13/2010 23:39:49.115'!
release

	self isConnected ifTrue: [self disconnect].
	^ super release! !

!SyClient methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:26:06.706'!
repository

	^ repository! !

!SyClient methodsFor: 'connection-handling' stamp: 'SR 6/7/2010 10:02:38.587'!
startConnectionThread

	connectionProcess := [
		[socket isConnected] whileTrue: [
			socket waitForDataIfClosed: [self disconnect].
			(protocolProcessor processDataFrom: socket)
				ifFalse: [self disconnect]]] sqFork.! !

!SyClient methodsFor: 'command handling' stamp: 'SR 6/7/2010 09:59:54.799'!
startIncomingCommandProcess
	"This process triggers the continous work of the server."
	
	incomingCommandProcess := [
		[self processIncomingCommands] repeat.
	] sqFork.! !

!SyClient methodsFor: 'orchestration' stamp: 'rkrk 6/14/2010 00:28:20.513'!
update: anAspect with: command

	(anAspect = #operation) ifFalse: [super update: anAspect with: command].

	pendingApplyCommandQueue nextPut: command.
	shouldDeferSends ifFalse: [
		self pvtCheckPendingApplyCommandQueueWorker].! !

Object subclass: #SyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

SyCommand subclass: #SyApplyCommand
	instanceVariableNames: 'selector receiverUUIDString expectedVersion wasExecuted arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyApplyCommand class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:24:22.489'!
receiver: aRegisteredObject selector: aSelector arguments: anArray

	^ self new
		receiverUUIDString: aRegisteredObject uuid asString;
		selector: aSelector;
		arguments: anArray;
		expectedVersion: aRegisteredObject version;
		yourself.! !

!SyApplyCommand class methodsFor: 'execution' stamp: 'mt 6/15/2010 15:18:35.161'!
shouldBeReplicated

	^ true! !

!SyApplyCommand methodsFor: 'testing' stamp: 'SR 6/1/2010 09:57:39.714'!
= other

	^ self receiverUUID = other receiverUUID
		and: [self selector = other selector]
		and: [self arguments = other arguments]! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:22:01.583'!
arguments
	
	^ arguments! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:21:04.672'!
arguments: anObject

	arguments := anObject! !

!SyApplyCommand methodsFor: 'execution' stamp: 'SR 6/29/2010 11:31:25.597'!
execute: aSyRepository

	| regRecv |
	regRecv := aSyRepository registeredObjectForUUID: self receiverUUID.
	regRecv ifNil: [ ^ false].	
	
	"Transcript
		cr; show: 'Checking versions: ';
		show: regRecv version asString; space;
		show: self expectedVersion asString."

	"Check version."
	"regRecv version = self expectedVersion
		ifFalse: [ ^ false ]."
	
	WorldState addDeferredUIMessage: [
		aSyRepository dontCreateCommandsDuring: [
			regRecv client
				perform: self selector asSymbol
				withArguments: self arguments]].
	
	"Execution done. Now add to operation stack. Increase Version."
	regRecv operations add: self.
	self wasExecuted: true.
	^ true! !

!SyApplyCommand methodsFor: 'execution' stamp: 'mt 6/15/2010 16:01:41.218'!
executeWithResult: aRepository
	"If this command is sent blocking to the server, then this message should be called on the return value to see if the apply-command was accepted."

	self wasExecuted
		ifTrue: [
			"Increase version."
			(aRepository registeredObjectForUUID: self receiverUUID) operations add: self]
		ifFalse: [SyApplyCommandRefusedException signal].! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/12/2010 14:20:16.92'!
expectedVersion
	"Specifies the expected version number that has to be verified before performing the method call on the receiver."

	^ expectedVersion! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/12/2010 14:20:35.269'!
expectedVersion: anInteger

	expectedVersion := anInteger.! !

!SyApplyCommand methodsFor: 'printing' stamp: 'SR 6/14/2010 22:59:30.901'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self receiverUUID;
		nextPutAll: '>>#';
		nextPutAll: self selector;
		nextPut: $).! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'rkrk 6/2/2010 21:51:19.365'!
receiverUUID

	^ UUID fromString: self receiverUUIDString! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/5/2010 19:20:05.904'!
receiverUUIDString

	^ receiverUUIDString! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/5/2010 19:20:09.051'!
receiverUUIDString: anObject

	receiverUUIDString := anObject! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:20:57.086'!
selector

	^ selector! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:20:53.995'!
selector: anObject

	selector := anObject! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/13/2010 10:13:53.676'!
wasExecuted

	^ wasExecuted ifNil: [wasExecuted := false]! !

!SyApplyCommand methodsFor: 'accessing' stamp: 'mt 6/12/2010 19:09:57.172'!
wasExecuted: aBoolean

	wasExecuted := aBoolean.! !

!SyCommand class methodsFor: 'testing' stamp: 'mt 6/15/2010 15:17:01.606'!
needsObjectMapping
	"Returns whether this command should be serialised using the repository object mapping."
	^ true! !

!SyCommand class methodsFor: 'testing' stamp: 'mt 6/15/2010 15:17:20.567'!
shouldBeReplicated
	"Returns whether this command should be replicated to all other clients"

	^ false! !

!SyCommand methodsFor: 'comparing' stamp: 'SR 6/1/2010 14:42:27.575'!
= anObject

	(self className = anObject className) ifFalse: [^ false].
	(self class instSize = anObject class instSize) ifFalse: [^ false].
	self instanceVariableValues withIndexDo: [ :value :index | ((anObject instVarAt: index) = value) ifFalse: [^ false]].
	
	^ true
	! !

!SyCommand methodsFor: 'execution' stamp: 'SR 6/1/2010 10:48:12.618'!
execute: aSyRepository
	"Should implement the functionality of this command. For now only the repository is supplied. Should return false if connection should be closed. Otherwise true."
	
	self subclassResponsibility! !

!SyCommand methodsFor: 'execution' stamp: 'SR 6/5/2010 19:18:58.009'!
executeWithResult: aSyRepository
	"If the command has a special meaning when it is executed on the sender side after being executed on the receiver side, this should be overridden. Parameter and results are the same as with #execute:"! !

SyCommand subclass: #SyListCommand
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyListCommand commentStamp: 'SR 6/1/2010 14:12:13.781' prior: 0!
Example command: {"type": "command", "command": {"instVars": [null], "class": "SyListCommand"}, "id": 0}!

!SyListCommand class methodsFor: 'testing' stamp: 'mt 6/15/2010 15:17:39.026'!
needsObjectMapping

	^ false! !

!SyListCommand methodsFor: 'execution' stamp: 'mt 6/19/2010 14:55:12.942'!
execute: aSyRepository

	objects := aSyRepository metaRepository.
	^ true! !

!SyListCommand methodsFor: 'execution' stamp: 'mt 6/22/2010 18:12:20.491'!
executeWithResult: aSyRepository

	aSyRepository dontCreateCommandsDuring: [
		objects do: [:regObject |
			[aSyRepository
				register: regObject client
				uuid: regObject uuid
				version: regObject version
				asRoot: regObject isRoot]
			on: SyAlreadyRegisteredException
			do: ["Ignore possibly already registered objects."]]].
	^ true! !

!SyListCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:45:57.765'!
objects

	^ objects! !

!SyListCommand methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:46:00.502'!
objects: anObject

	objects := anObject! !

!SyListCommand methodsFor: 'execution' stamp: 'SR 6/14/2010 19:49:53.155'!
pvtCreateRegObjectDictionary: aRegisteredObject

	^ Dictionary newFrom: {
		#uuidString -> aRegisteredObject uuidString.
		#version -> aRegisteredObject version.
		#client -> aRegisteredObject client.}! !

SyCommand subclass: #SyQuitCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyQuitCommand commentStamp: 'SR 6/1/2010 14:12:24.447' prior: 0!
Example command: {"type": "command", "command": {"instVars": [], "class": "SyQuitCommand"}, "id": 1}!

!SyQuitCommand methodsFor: 'execution' stamp: 'SR 6/5/2010 19:18:16.985'!
execute: aSyRepository

	SyClientClosedConnectionException signal! !

SyCommand subclass: #SyRegisterCommand
	instanceVariableNames: 'client uuid versionOffset asRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyRegisterCommand class methodsFor: 'instance creation' stamp: 'mt 6/19/2010 14:28:26.203'!
client: anObject uuid: aUUID versionOffset: aVersionNumber asRoot: aBoolean

	^ self new 
			client: anObject;
			uuid: aUUID;
			versionOffset: aVersionNumber;
			asRoot: aBoolean! !

!SyRegisterCommand class methodsFor: 'testing' stamp: 'mt 6/19/2010 14:44:38.693'!
needsObjectMapping

	^ false! !

!SyRegisterCommand class methodsFor: 'testing' stamp: 'SR 6/18/2010 15:33:24.715'!
shouldBeReplicated
	"Returns whether this command should be replicated to all other clients"

	^ true! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:52.735'!
asRoot

	^ asRoot! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:48.993'!
asRoot: anObject

	asRoot := anObject! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:05:03.911'!
client

	^ client! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:05:07.709'!
client: anObject

	client := anObject! !

!SyRegisterCommand methodsFor: 'execution' stamp: 'mt 6/19/2010 14:59:44.925'!
execute: aSyRepository

	[aSyRepository dontCreateCommandsDuring: [
		aSyRepository
			register: self client
			uuid: self uuid
			version: self versionOffset
			asRoot: self asRoot]]
	on: SyAlreadyRegisteredException
	do: ["If it is already everything is ok already"].
	^ true
	.
	! !

!SyRegisterCommand methodsFor: 'execution' stamp: 'SR 6/18/2010 15:46:30.554'!
executeWithResult: aSyRepository

	^ true! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:22.941'!
uuid

	^ uuid! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:26.093'!
uuid: anObject

	uuid := anObject! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:30.04'!
versionOffset

	^ versionOffset! !

!SyRegisterCommand methodsFor: 'accessing' stamp: 'mt 6/19/2010 14:29:32.968'!
versionOffset: anObject

	versionOffset := anObject! !

SyCommand subclass: #SyResultProxyCommand
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyResultProxyCommand commentStamp: 'mt 6/13/2010 15:30:21.46' prior: 0!
Use this command to redirect #executeWithResult: to #execute: for any given command.!

!SyResultProxyCommand class methodsFor: 'instance creation' stamp: 'mt 6/13/2010 15:30:51.035'!
forCommand: aCommand

	^ self new
		command: aCommand! !

!SyResultProxyCommand methodsFor: 'accessing' stamp: 'mt 6/13/2010 15:31:06'!
command

	^ command! !

!SyResultProxyCommand methodsFor: 'accessing' stamp: 'mt 6/13/2010 15:31:13.062'!
command: aCommand

	command := aCommand.! !

!SyResultProxyCommand methodsFor: 'execution' stamp: 'mt 6/13/2010 15:31:36.929'!
execute: aRepository

	^ self command executeWithResult: aRepository! !

Object subclass: #SyProtocolProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SyProtocolProcessor methodsFor: 'receiving' stamp: 'mt 6/12/2010 19:50:29.738'!
processDataFrom: aStream

	self subclassResponsibility.! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 5/20/2010 18:27:17.111'!
sendCommandBlocking: aCommandString on: aStream
	"Sends command to server and returns its answer. Responsible for command-response-scheme."
	
	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:46:29.438'!
sendCommandNonBlocking: anOperation on: aStream
	"Sends a command to the server, but does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/5/2010 19:50:05.89'!
sendCommandNonBlocking: aSyCommand onAll: someStreams
	"Sends a command to some servers/clients, but does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

!SyProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:47:04.728'!
sendCommandResult: aCommand with: aCommandId on: aStream
	"Sends a command back after it has been processed, does so asynchronously. Therefore all implementions should return fast."

	self subclassResponsibility! !

SyProtocolProcessor subclass: #SySimpleProtocolProcessor
	instanceVariableNames: 'outgoingQueue outgoingQueueWorker incomingQueue currentCommandResultCache currentCommandResultSemaphore currentCommandResultId nextCommandID objectMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Shared'!

!SySimpleProtocolProcessor commentStamp: 'mt 5/31/2010 09:15:17.382' prior: 0!
Wire Protocol
---

1) All data is serialized or deserialized according to #serialize: and #deserialize:.

2) In a first version, JSON is used to serialize messages.

3) Messages are separated on the wire using a unique #messageEndToken.

4) Each message is dictionary with the following content:
	#channel -> aNumber
	#data -> aString
	
5) There is a #channel for commands, one for results of commands, and one for operations/updates.

6) For each command an increasing ID is sent along to verify the result on the command result channel:
	#id -> aNumber
	#command -> aString
	
7) The result of a command is as follows:
	#id -> aNumber
	#result -> aString
	
8) Update messages have to be deserialized in the #data field.!

!SySimpleProtocolProcessor class methodsFor: 'constants' stamp: 'SR 6/1/2010 12:24:19.963'!
messageEndToken
	"Return the token that will be transferred after the end of each message to allow the recipient of the message to recognize it fully. No message should contain this token."
	
	^ String crlf! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 6/15/2010 15:09:48.087'!
deserialize: aByteString withMapping: aBoolean

	^ SyReferenceMappingStream
		unStream: (ByteArray readFrom: aByteString)
		mapping: (aBoolean ifTrue: [self objectMapping] ifFalse: [])! !

!SySimpleProtocolProcessor methodsFor: 'initialize-release' stamp: 'mt 6/15/2010 15:37:39.45'!
initialize

	super initialize.
	outgoingQueue := SharedQueue new. "To send outgoing commands."
	incomingQueue := SharedQueue new. "To schedule incoming commands."
	
	currentCommandResultSemaphore := Semaphore new. "To wait for command results."
	nextCommandID := 0.
	
	objectMapping := SyReferenceMapping identity.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'rkrk 6/13/2010 23:40:11.99'!
killOutgoingQueueWorker
	"Only use in client mode."

	outgoingQueueWorker isNilOrTerminated
		ifFalse: [outgoingQueueWorker terminate].! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 6/1/2010 13:59:39.663'!
nextCommand
	"Retrieve the next pending command from the incoming command queue."
	
	^ incomingQueue next! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'mt 6/13/2010 15:28:26.257'!
nextCommandPutLocal: aCommand
	"Schedule a command that was obiously created locally and has to be processed locally too. Intent: Reusage of incomingQueue for process synchronization."
	
	incomingQueue nextPut: {
		-1. "Local command."
		aCommand.
		nil}.! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:45:15.615'!
nextUpdate
	"Retrieve the next pending operation from the incoming update queue."
	
	^ incomingQueue next! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 6/14/2010 19:32:09.217'!
objectMapping

	^ objectMapping! !

!SySimpleProtocolProcessor methodsFor: 'accessing' stamp: 'SR 6/14/2010 19:32:12.091'!
objectMapping: anObject

	objectMapping := anObject! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'mt 6/15/2010 15:20:57.869'!
processDataFrom: aStream
	"Depending on the channel, process the data"
	
	| message command rawMessage commandClass |
	rawMessage := aStream upToAll: SySimpleProtocolProcessor messageEndToken.
	rawMessage isEmpty ifTrue: [^ false].
	
	message := self deserialize: rawMessage withMapping: false.
	commandClass := Smalltalk classNamed: (message at: #commandClass).
	command := self deserialize: (message at: #command) withMapping: commandClass needsObjectMapping.

	((message at: #type) = 'command') ifTrue: [
		^ self
			pvtProcessCommand: command
			with: (message at: #id)
			from: aStream].
			
	((message at: #type) = 'result') ifTrue: [
		^ self
			pvtProcessCommandResult: command
			with: (message at: #id)
			from: aStream].
			
! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:33:43.392'!
pvtCheckOutgoingQueueWorker
	"Only use in client mode."

	outgoingQueueWorker isNilOrTerminated ifTrue: [
		outgoingQueueWorker := [ | opArray operationDict |
			opArray := outgoingQueue nextOrNil.
			[opArray isNil] whileFalse: [
				self
					pvtSendCommand: opArray second
					with: opArray first
					on: opArray third.
				opArray := outgoingQueue nextOrNil]] sqFork].! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'rkrk 6/15/2010 00:40:01.712'!
pvtCreateCommand: aDictionary

	| typeName variableData newObject |
	typeName := aDictionary at: #class.
	variableData := aDictionary at: #instVars.
	
	newObject := (Smalltalk classNamed: typeName asSymbol) new.
	variableData withIndexDo: [:value :index | newObject instVarAt: index put: value].
	
	^ newObject! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/1/2010 11:54:22.057'!
pvtNextCommandId

	| result |
	result := nextCommandID.
	nextCommandID := nextCommandID + 1.
	^ result! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 6/1/2010 13:51:25.804'!
pvtProcessCommand: aCommand with: aCommandId from: aStream
	"Support commands."
	
	"Schedule incoming command to be processed by client or server application."
	incomingQueue nextPut: {
		aCommandId.
		aCommand.
		aStream}.
		
	^ true! !

!SySimpleProtocolProcessor methodsFor: 'receiving' stamp: 'SR 6/1/2010 13:51:33.336'!
pvtProcessCommandResult: aCommand with: aCommandId from: aStream
	"Save the command result and signal."
	
	currentCommandResultId := aCommandId.
	currentCommandResultCache := aCommand.
	currentCommandResultSemaphore signal.

	"Never close connection"
	^ true! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'mt 6/15/2010 15:26:43.641'!
pvtSendCommand: aCommand with: aCommandId on: aStream

	| data dict |
	dict := Dictionary newFrom: {
		#id -> aCommandId.
		#type -> 'command'.
		#commandClass -> aCommand className.
		#command -> (self serialize: aCommand withMapping: aCommand class needsObjectMapping).}.
	data := self serialize: dict withMapping: false.
	
	aStream nextPutAll: data , SySimpleProtocolProcessor messageEndToken.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:33:58.437'!
sendCommandBlocking: command on: stream
	"Sends a command and returns its answer. Responsible for command-response-scheme."

	| commandId |
	commandId := self
		sendCommandNonBlocking: command
		on: stream.
	[currentCommandResultId = commandId] whileFalse: [ 
		currentCommandResultSemaphore wait].
	^ currentCommandResultCache.! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:35:19.306'!
sendCommandNonBlocking: aSyCommand on: aStream

	| commandId |
	commandId := self pvtNextCommandId.
	outgoingQueue nextPut: {commandId. aSyCommand. aStream.}.
	self pvtCheckOutgoingQueueWorker.
	
	^ commandId! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'SR 6/14/2010 19:35:44.447'!
sendCommandNonBlocking: aSyCommand onAll: someStreams

	^ someStreams collect: [:aStream | 
		self
			sendCommandNonBlocking: aSyCommand
			on: aStream].! !

!SySimpleProtocolProcessor methodsFor: 'sending' stamp: 'mt 6/15/2010 15:39:04.504'!
sendCommandResult: aCommand with: aCommandId on: aStream
	"Sends command result repeating the given ID so that the sender of the command can map the result correctly."

	| data dict |
	dict := Dictionary newFrom: {
		#id -> aCommandId.
		#type -> 'result'.
		#commandClass -> aCommand className.
		#command -> (self serialize: aCommand withMapping: aCommand class needsObjectMapping).}.
	data := self serialize: dict withMapping: true.
	
	aStream nextPutAll: data , SySimpleProtocolProcessor messageEndToken.! !

!SySimpleProtocolProcessor methodsFor: 'serialisation' stamp: 'mt 6/15/2010 15:07:46.568'!
serialize: anObject withMapping: aBoolean

	^ (SyReferenceMappingStream
		streamedRepresentationOf: anObject
		mapping: (aBoolean ifTrue: [self objectMapping] ifFalse: [])) storeString! !

Object subclass: #SyReference
	instanceVariableNames: 'uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyReference class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 16:11:30.775'!
fromRegisteredObject: aSyRegisteredObject

	^ self new uuid: aSyRegisteredObject uuid! !

!SyReference methodsFor: 'accessing' stamp: 'mt 6/15/2010 16:10:51.52'!
uuid

	^ uuid! !

!SyReference methodsFor: 'accessing' stamp: 'mt 6/15/2010 16:11:00.598'!
uuid: aUUID

	uuid := aUUID! !

Object subclass: #SyReferenceMapping
	instanceVariableNames: 'foreward backward'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SyReferenceMapping commentStamp: 'mt 6/15/2010 14:58:21.783' prior: 0!
The mappings are blocks exepecting one argument (the object to be mapped)!

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:34:11.102'!
backward: aBackwardMappingBlock

	^ self new backward: aBackwardMappingBlock! !

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:34:01.166'!
foreward: aForwardMappingBlock

	^ self new foreward: aForwardMappingBlock! !

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:32:40.963'!
foreward: aForwardMappingBlock backward: aBackwardMappingBlock

	^ self new
		foreward: aForwardMappingBlock;
		backward: aBackwardMappingBlock! !

!SyReferenceMapping class methodsFor: 'instance creation' stamp: 'mt 6/15/2010 15:35:38.664'!
identity

	^ self new! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:10:39.715'!
backward

	^ backward ifNil: [ backward := [:o | o]]! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:02:24.813'!
backward: anObject

	backward := anObject! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:10:50.078'!
foreward

	^ foreward ifNil: [ foreward := [:o | o]]! !

!SyReferenceMapping methodsFor: 'accessing' stamp: 'mt 6/15/2010 15:02:14.592'!
foreward: anObject

	foreward := anObject! !

Object subclass: #SyRegisteredObject
	instanceVariableNames: 'uuid client operations versionOffset isRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyRegisteredObject commentStamp: 'mt 6/15/2010 15:59:45.823' prior: 0!
Rename me?!

!SyRegisteredObject class methodsFor: 'instance creation' stamp: 'SR 6/14/2010 18:40:25.654'!
client: anObject uuid: aUUID versionOffset: aVersionNumber asRoot: aBoolean

	^ self new
		client: anObject;
		uuid: aUUID;
		versionOffset: aVersionNumber;
		isRoot: aBoolean;
		yourself.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:53.286'!
client

	^ client! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:49.519'!
client: anObject

	client := anObject! !

!SyRegisteredObject methodsFor: 'initialize-release' stamp: 'SR 5/17/2010 20:02:07.393'!
initialize

	super initialize.
	operations := OrderedCollection new.! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:40:17.638'!
isRoot

	^ isRoot! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/14/2010 18:40:13.583'!
isRoot: aBoolean

	isRoot := aBoolean! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/6/2010 14:35:45.967'!
operations

	^ operations! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/6/2010 14:35:49.859'!
operations: anObject

	operations := anObject! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:43.328'!
uuid

	^ uuid! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'SR 6/1/2010 10:04:46.39'!
uuid: anObject

	uuid := anObject! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'rkrk 6/2/2010 11:54:26.291'!
uuidString

	^ self uuid asString! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/12/2010 15:16:25.975'!
version
	"Return an integer that represents the version of this object with:
	o1 isNewer o2 --> o1 version > o2 version"
	
	^ self operations size + self versionOffset! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/12/2010 15:16:39.679'!
versionOffset
	"If only the latest operations are available in the stack, this offset can be used to calculate the real version."
	
	^ versionOffset ifNil: [versionOffset := 0]! !

!SyRegisteredObject methodsFor: 'accessing' stamp: 'mt 6/12/2010 15:16:16.786'!
versionOffset: anInteger
	
	versionOffset := anInteger.! !

Object subclass: #SyRepository
	instanceVariableNames: 'objects instrumentor shouldCreateCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyRepository methodsFor: 'repository' stamp: 'rkrk 6/2/2010 12:58:43.044'!
all

	^ objects collect: [:regObject | regObject client]! !

!SyRepository methodsFor: 'reference mapping' stamp: 'SR 6/18/2010 15:58:42.456'!
backwardReferenceMappingBlock

	^  [:obj | 
		obj class == SyReference
			ifTrue: [(self registeredObjectForReference: obj) ifNotNilDo: [:obj2| obj2 client]]
			ifFalse: [obj]]! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 10:28:01.527'!
clear

	objects := OrderedCollection new.
	instrumentor uninstrumentAllAndReset.! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/19/2010 14:59:44.892'!
dontCreateCommandsDuring: block

	| tmp |
	tmp := self shouldCreateCommands.
	self shouldCreateCommands: false.
	block value.
	self shouldCreateCommands: tmp.! !

!SyRepository methodsFor: 'reference mapping' stamp: 'mt 6/15/2010 16:02:40.003'!
forewardReferenceMappingBlock

	^ [:obj | |regObject|
		regObject := self registeredObjectForDomainObject: obj.
		regObject
			ifNil: [obj]
			ifNotNil: [SyReference fromRegisteredObject: regObject]].! !

!SyRepository methodsFor: 'initialize-release' stamp: 'mt 6/19/2010 15:54:18.229'!
initialize

	super initialize.

	objects := OrderedCollection new.
	instrumentor := SyClassInstrumentor new processor: self.
	
	shouldCreateCommands := false.! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 09:41:38.775'!
isEmpty

	^ objects isEmpty! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 09:30:15.455'!
metaRepository

	^ objects! !

!SyRepository methodsFor: 'method wrappers' stamp: 'SR 6/30/2010 11:58:10.069'!
process: selector on: obj with: args hasSideEffects: aBoolean

	| registeredObject applyCommand |
	"Only methods with side effects are intersting"
	aBoolean ifFalse: [^ self].
	
	"Recursion exit condition. Allows multiple clients/servers per Image in combination with multiple SyMethodWrappers."
	registeredObject := (self registeredObjectForDomainObject: obj) ifNil: [^ self].
	
	self pvtCheckArguments: args.
	
	applyCommand := SyApplyCommand
		receiver: registeredObject
		selector: selector
		arguments: args.
		
	self changed: #operation with: applyCommand! !

!SyRepository methodsFor: 'method wrappers' stamp: 'SR 6/18/2010 15:55:16.467'!
pvtCheckArguments: args.
	
	args do: [:obj |
		obj isSqEntityType ifTrue: [
			(self registeredObjectForDomainObject: obj) ifNil: [
				self register: obj]]].! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/12/2010 15:18:43.373'!
register: anObject

	^ self register: anObject uuid: UUID new! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/12/2010 15:22:32.958'!
register: anObject uuid: aUUID

	^ self
		register: anObject
		uuid: aUUID
		version: 0 "New object."! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/14/2010 18:38:17.287'!
register: anObject uuid: aUUID version: aVersionNumber

	^ self register: anObject uuid: aUUID version: aVersionNumber asRoot: false! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/19/2010 14:59:32.537'!
register: anObject uuid: aUUID version: aVersionNumber asRoot: aBoolean

	| registeredObject |
	(self all identityIncludes: anObject) ifTrue: [
		SyAlreadyRegisteredException signal: 'Object already registered'].
	(objects anySatisfy: [:regObject |
		regObject uuid = aUUID]) ifTrue: [
			SyAlreadyRegisteredException signal: 'UUID already registered'].
	
	registeredObject := SyRegisteredObject
		client: anObject
		uuid: aUUID
		versionOffset: aVersionNumber
		asRoot: aBoolean.
	objects add: registeredObject.
	
	"Wrap objects class if not yet wrapped"
	self shouldCreateCommands ifTrue: [ 
		instrumentor instrumentClass: anObject class].
	
	"Replicate"
	self shouldCreateCommands ifTrue: [ | registerCommand |
		registerCommand := SyRegisterCommand
			client: anObject
			uuid: aUUID
			versionOffset: aVersionNumber
			asRoot: aBoolean.
		
		self changed: #operation with: registerCommand].
	
	^ registeredObject.! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/15/2010 16:00:38.81'!
registeredObjectForDomainObject: aDomainObject

	^ objects
		detect: [:regObj | regObj client == aDomainObject]
		ifNone: []! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/15/2010 16:01:41.036'!
registeredObjectForReference: aSyReference

	^ self registeredObjectForUUID: aSyReference uuid! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/15/2010 16:01:40.784'!
registeredObjectForUUID: aUUID

	^ objects
		detect: [:regObj | regObj uuid = aUUID]
		ifNone: [].! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/15/2010 16:01:40.879'!
resolve: aUUID

	^ (self registeredObjectForUUID: aUUID) ifNotNilDo: [ :ro| ro client]
! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/14/2010 18:44:57.93'!
rootObject

	^ (objects detect: [:o | o isRoot ] ifNone: [^ nil]) client! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/14/2010 18:41:52.466'!
rootObject: anObject

	^ self register: anObject uuid: UUID new version: 0 asRoot: true! !

!SyRepository methodsFor: 'accessing' stamp: 'mt 6/19/2010 15:54:18.36'!
shouldCreateCommands

	^ shouldCreateCommands! !

!SyRepository methodsFor: 'accessing' stamp: 'mt 6/19/2010 15:54:18.321'!
shouldCreateCommands: aBoolean

	shouldCreateCommands := aBoolean.
	self updateMethodWrappers: aBoolean.! !

!SyRepository methodsFor: 'repository' stamp: 'SR 6/1/2010 14:14:09.691'!
size

	^ objects size! !

!SyRepository methodsFor: 'repository' stamp: 'mt 6/19/2010 14:59:32.586'!
unregister: anObject

	objects removeAllSuchThat: [:regObject | regObject client == anObject].
	
	self shouldCreateCommands ifTrue: [
		(objects contains: [:o | o client class == anObject class]) ifFalse: [
			instrumentor uninstrumentClass: (anObject class)]].! !

!SyRepository methodsFor: 'method wrappers' stamp: 'SR 6/1/2010 09:45:23.992'!
updateMethodWrappers: aBoolean

	aBoolean ifTrue: [
		"enable Method Wrappers for all classes".
		self all do: [ :o | instrumentor instrumentClass: (o class) ].
		
	] ifFalse: [
		"disable Method Wrappers for all classes."
		instrumentor uninstrumentAllAndReset.
	]! !

Object subclass: #SyServer
	instanceVariableNames: 'tcpServer repository mainProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyServer commentStamp: 'SR 5/27/2010 12:19:26.044' prior: 0!
Extends a TCP server with some managed objects.

Idea: Maybe we should composite this with a tcp server and not inherit from that...

Example:

| server o1 o2 |
server := SySimpleServer new.
o1 := Person givenName: 'Micha' surname: 'Test'.
o2 := Person givenName: 'Christoph' surname: 'Muster'.
server
	register: o1;
	register: o2;
	start;
	inspect.!

!SyServer class methodsFor: 'defaults' stamp: 'mt 5/26/2010 12:59:10.538'!
defaultPort

	^ 22701! !

!SyServer methodsFor: 'signals' stamp: 'mt 6/23/2010 15:59:46.309'!
commandExecuted: aCommandClass

	self emit.! !

!SyServer methodsFor: 'signals' stamp: 'mt 6/13/2010 16:18:21.032'!
connectionsChanged

	self emitAlways.! !

!SyServer methodsFor: 'initialize-release' stamp: 'mt 6/22/2010 16:56:02.389'!
initialize

	super initialize.
	
	tcpServer := SyTcpServer new.
	self connect: tcpServer signal: #connectionsChanged toSelector: #connectionsChanged.

	repository := SyRepository new.
		
	tcpServer protocolProcessor: (SySimpleProtocolProcessor new
			objectMapping: (SyReferenceMapping foreward: repository forewardReferenceMappingBlock backward: repository backwardReferenceMappingBlock)).! !

!SyServer methodsFor: 'debugging' stamp: 'rkrk 6/2/2010 14:47:16.469'!
log: msg

	Transcript cr; show: msg asString.! !

!SyServer methodsFor: 'command handling' stamp: 'mt 6/23/2010 16:00:05.605'!
processIncomingCommands
	"See SySimpleProtocolProcessor>>pvtProcessCommand:senderID: for more infos."
	
	| array commandId command senderStream |
	array := tcpServer protocolProcessor nextCommand.

	commandId := array first.
	command := array second.
	senderStream := array third.
	
	self log: 'SyServer processing: ' , command asString.
	
	[
		| succeeded |
		succeeded := command execute: self repository.
		self commandExecuted: command class.
		
		tcpServer protocolProcessor
			sendCommandResult: command
			with: commandId
			on: senderStream.
		succeeded & command class shouldBeReplicated ifTrue: [
			"Replicate the command if neccessary"
			self log: 'Server broadcasting: ' , command asString.
			tcpServer protocolProcessor
				sendCommandNonBlocking: command
				onAll: (tcpServer connections copyWithout: senderStream)]
	]
	on: SyClientClosedConnectionException
	do: [senderStream close].
	
! !

!SyServer methodsFor: 'initialize-release' stamp: 'mt 6/22/2010 16:56:55.999'!
release

	self stop.	
	super release.! !

!SyServer methodsFor: 'repository' stamp: 'SR 6/1/2010 10:28:57.017'!
repository

	^ repository! !

!SyServer methodsFor: 'start-stop' stamp: 'mt 6/22/2010 16:55:46.97'!
start

	self startMainProcess.
	tcpServer listenOn: self class defaultPort.! !

!SyServer methodsFor: 'command handling' stamp: 'mt 5/31/2010 09:20:45.756'!
startMainProcess
	"This process triggers the continous work of the server."
	
	mainProcess := [
		[self processIncomingCommands] repeat.
	] fork.! !

!SyServer methodsFor: 'start-stop' stamp: 'mt 7/11/2010 11:29:00.259'!
stop

	tcpServer close.
	mainProcess ifNotNilDo: [:proc | proc terminate. mainProcess := nil].! !

Object subclass: #SyTcpServer
	instanceVariableNames: 'listenSocket listenProcess connections connectionProcesses connectionChangesMonitor protocolProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Server'!

!SyTcpServer commentStamp: 'mt 5/19/2010 12:50:32.652' prior: 0!
I am able to accept and manage incoming TCP connections.!

!SyTcpServer methodsFor: 'handling' stamp: 'mt 7/11/2010 11:50:11.9'!
close

	"Closing listen part"
	listenProcess ifNotNilDo: [:p | p terminate. listenProcess := nil].
		
	"Closing connection part"
	self connectionProcesses do: [:proc | proc terminate].
	self connectionProcesses removeAll.
	
	! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'SR 5/10/2010 17:28:42.275'!
connectionProcesses

	^ connectionProcesses ifNil: [connectionProcesses := SySharedList new]! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:46:22.708'!
connections

	^ connections ifNil: [connections := SySharedList new]! !

!SyTcpServer methodsFor: 'signals' stamp: 'SR 6/3/2010 11:59:48.882'!
connectionsChanged

	self emit! !

!SyTcpServer methodsFor: 'testing' stamp: 'mt 5/9/2010 16:17:23.888'!
isListening

	^ self listenSocket isWaitingForConnection! !

!SyTcpServer methodsFor: 'listening' stamp: 'rkrk 5/14/2010 13:30'!
listenOn: aPort

	self isListening ifTrue: [self error: 'Server already listening!!'].
	self listenSocket listenOn: aPort backlogSize: 4.
	self startListenThread.! !

!SyTcpServer methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 15:58:25.953'!
listenSocket

	^ listenSocket ifNil: [listenSocket := Socket newTCP]! !

!SyTcpServer methodsFor: 'listening' stamp: 'mt 5/29/2010 12:32:13.073'!
listenerProcessPriority

	^ Processor lowIOPriority! !

!SyTcpServer methodsFor: 'debugging' stamp: 'rkrk 5/14/2010 17:31'!
log: msg

	Transcript cr; show: msg asString.! !

!SyTcpServer methodsFor: 'handling' stamp: 'SR 6/3/2010 11:47:27.907'!
newConnectionOn: socket

	| con |
	con := SyTcpSocket on: socket.
	self connections add: con.
	self startConnectionThreadFor: con.
	
	self connectionsChanged.
! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/9/2010 17:12:59.484'!
port

	^ self listenSocket port! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/29/2010 10:32:05.82'!
protocolProcessor

	^ protocolProcessor! !

!SyTcpServer methodsFor: 'accessing' stamp: 'mt 5/26/2010 13:02:36.831'!
protocolProcessor: aProtocolProcessor

	protocolProcessor := aProtocolProcessor.! !

!SyTcpServer methodsFor: 'handling' stamp: 'SR 6/3/2010 11:48:12.249'!
startConnectionThreadFor: socket

	| connectionProcess |
	connectionProcess := [
		[[socket isConnected] whileTrue: [
				socket waitForDataIfClosed: [Processor activeProcess terminate].
				self protocolProcessor ifNotNilDo: [:p |
					(p processDataFrom: socket) ifFalse: [Processor activeProcess terminate]].
		]] ensure: [
			socket close.
			self connections remove: socket ifAbsent: [].
			self log: 'Some client socket closed'; log: socket debug.
			self connectionsChanged].
	] newProcess.
	self connectionProcesses add: connectionProcess.
	connectionProcess resume.! !

!SyTcpServer methodsFor: 'listening' stamp: 'mt 5/31/2010 08:01:17.378'!
startListenThread
	
	listenProcess := [
		[[self isListening] whileTrue: [
				(self listenSocket waitForAcceptFor: 3) ifNotNilDo: [:socket |
					self newConnectionOn: socket.
					self log: 'New client connected: ' , socket remoteAddress , ' ' , socket statusString]]
		] ensure: [
			self log: 'listener terminating, socket: ' , (listenSocket ifNotNilDo: [:s | s statusString]).
			listenSocket isValid ifTrue: [listenSocket closeAndDestroy].
			listenSocket := nil]
	] newProcess.

	listenProcess
		priority: self listenerProcessPriority;
		name: self class name, '''s listener process';
		resume.! !

SocketStream subclass: #SyTcpSocket
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SyTcpSocket class methodsFor: 'instance creation' stamp: 'mt 5/10/2010 11:05:32.461'!
connectToHost: nameOrAddressString port: anInteger
	
	^ self
		openConnectionToHostNamed: nameOrAddressString
		port: anInteger! !

!SyTcpSocket methodsFor: 'testing' stamp: 'SR 6/3/2010 14:18:00.28'!
isConnected
	"Fix socket bug under windows. Trigger a new receive operation to force status update in the plugin."
	
	[
		self adjustInBuffer: (self socket
			receiveDataNonBlockingInto: inBuffer
			startingAt: inNextToWrite).
		^ self socket isConnected]
	on: Exception
	do: [^ false]! !

!SyTcpSocket methodsFor: 'stream out' stamp: 'SR 6/3/2010 14:14:51.528'!
nextPutAll: aCollection
	"Overridden to be better testable with a normal stream. Use the optimized version #nextPutAllFlush:."
	
	^ self isConnected
		ifTrue: [self nextPutAllFlush: aCollection]
		ifFalse: [nil]! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:48.023'!
remoteAddress

	^ self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:34:56.652'!
remoteAddressString

	^ NetNameResolver stringFromAddress: self socket remoteAddress! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/30/2010 21:36:39.6'!
remoteID

	^ self remoteAddressString, ':', self remotePort asString! !

!SyTcpSocket methodsFor: 'accessing' stamp: 'mt 5/10/2010 11:23:53.871'!
remotePort

	^ self socket remotePort! !

!SyTcpSocket methodsFor: 'waiting' stamp: 'mt 5/9/2010 17:23:15.848'!
waitForDataIfClosed: aBlock

	^ self socket waitForDataIfClosed: aBlock! !

!Socket methodsFor: '*SqSync' stamp: 'mt 5/31/2010 12:13:53.535'!
forceStatusUpdate
	"Workaround for broken Windows socket plugin. Better use SyTcpSocket where #isConnected will not loose any bytes if available."

	self
		receiveDataNonBlockingInto: ' '
		startingAt: 1.! !

!Socket methodsFor: '*SqSync' stamp: 'mt 5/31/2010 12:14:08.19'!
receiveDataNonBlockingInto: aStringOrByteArray startingAt: aNumber
	"To be used to fix the status bug under Windows."

	^ self primSocket: socketHandle
		receiveDataInto: aStringOrByteArray
		startingAt: aNumber
		count: aStringOrByteArray size - aNumber + 1! !

!BlockClosure methodsFor: '*SqSync' stamp: 'SR 6/7/2010 10:03:54.1'!
sqFork

	^ self sqForkAt: Processor activeProcess priority! !

!BlockClosure methodsFor: '*SqSync' stamp: 'SR 6/7/2010 10:03:33.432'!
sqForkAt: aPriorityInteger

	^ [
		Processor activeProcess priority: aPriorityInteger.
		self value] forkAt: 60! !

OrderedCollection subclass: #SySharedList
	instanceVariableNames: 'mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tools'!

!SySharedList commentStamp: 'mt 5/9/2010 17:04:27.753' prior: 0!
This is meant to be a thread-safe version of an OrderedCollection. See the "list" protocol to explore selectors which are thread-safe.!

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:52:24.122'!
add: anElement

	^ self mutex critical: [super add: anElement].! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/31/2010 08:37:35.378'!
detect: aBlock ifNone: aNoneBlock

	^ self mutex critical: [super detect: aBlock ifNone: aNoneBlock]! !

!SySharedList methodsFor: 'accessing - private' stamp: 'mt 5/9/2010 16:40:52.25'!
mutex

	^ mutex ifNil: [mutex := Mutex new]! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/9/2010 16:53:19.735'!
remove: anElement ifAbsent: aBlock
	"#remove: should also be guarded now."
	
	^ self mutex critical: [super remove: anElement ifAbsent: aBlock].! !

!SySharedList methodsFor: 'list' stamp: 'mt 5/30/2010 19:50:56.398'!
size

	^ self mutex critical: [super size]! !

InstructionClient subclass: #SyInstVarStoreLocator
	instanceVariableNames: 'bingo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyInstVarStoreLocator methodsFor: 'initialize-release' stamp: 'SR 6/30/2010 11:11:31.211'!
interpretNextInstructionUsing: aScanner 
	
	bingo := false.
	aScanner interpretNextInstructionFor: self.
	^ bingo! !

!SyInstVarStoreLocator methodsFor: 'instruction decoding' stamp: 'SR 6/30/2010 11:15:07.048'!
popIntoReceiverVariable: offset 

	bingo := true! !

!SyInstVarStoreLocator methodsFor: 'instruction decoding' stamp: 'SR 6/30/2010 11:10:51.153'!
storeIntoReceiverVariable: offset 

	bingo := true! !

MwMethodWrapper subclass: #SyGUIProcessTestMethodWrapper
	instanceVariableNames: 'isGuiProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyGUIProcessTestMethodWrapper methodsFor: 'as yet unclassified' stamp: 'SR 6/29/2010 11:15:51.161'!
initialize

	super initialize.
	isGuiProcess := true.! !

!SyGUIProcessTestMethodWrapper methodsFor: 'accessing' stamp: 'SR 6/29/2010 11:09:23.392'!
isGuiProcess
	^ isGuiProcess! !

!SyGUIProcessTestMethodWrapper methodsFor: 'accessing' stamp: 'SR 6/29/2010 11:09:23.398'!
isGuiProcess: anObject
	isGuiProcess := anObject! !

!SyGUIProcessTestMethodWrapper methodsFor: 'evaluating' stamp: 'SR 6/29/2010 15:35:29.752'!
valueWithReceiver: anObject arguments: args

	(anObject class == Person) ifTrue: [
		Transcript cr; show: 'asdasd'; cr.
		isGuiProcess :=  isGuiProcess and: [Processor activeProcess == Project uiProcess]].
	^ super valueWithReceiver: anObject arguments: args! !

MwMethodWrapper subclass: #SyMethodWrapper
	instanceVariableNames: 'instrumentor storesIntoInstVar'
	classVariableNames: 'TLS'
	poolDictionaries: ''
	category: 'SqSync-Repository'!

!SyMethodWrapper class methodsFor: 'thread-local storage' stamp: 'SR 6/30/2010 11:49:34.775'!
getTlsValue

	TLS ifNil: [TLS := Dictionary new].
	^ TLS at: (Processor activeProcess) ifAbsent: []! !

!SyMethodWrapper class methodsFor: 'constants' stamp: 'mt 6/22/2010 17:37:48.213'!
notReplicatedSelectors

	^ #(= printOn: asString)! !

!SyMethodWrapper class methodsFor: 'instance creation' stamp: 'SR 5/16/2010 17:18:44.185'!
on: aSymbol inClass: aClass for: anInstrumentor

	| wrapper |
	wrapper := self on: aSymbol inClass: aClass.
	wrapper instrumentor: anInstrumentor.
	^ wrapper! !

!SyMethodWrapper class methodsFor: 'thread-local storage' stamp: 'SR 6/30/2010 11:49:38.333'!
setTlsValue: anObject

	TLS ifNil: [TLS := Dictionary new].
	TLS at: (Processor activeProcess) put: anObject! !

!SyMethodWrapper methodsFor: 'as yet unclassified' stamp: 'SR 7/11/2010 22:07:57.999'!
install

	super install.
	self clientMethod ifNotNilDo: [:ignore|
		storesIntoInstVar := self clientMethod isMwMethodWrapper
			ifTrue: [ self clientMethod storesIntoInstVar ]
			ifFalse: [ self clientMethod hasInstVarStore ]]! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:42.497'!
instrumentor

	^ instrumentor! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 5/16/2010 17:17:39.016'!
instrumentor: anObject

	instrumentor := anObject! !

!SyMethodWrapper methodsFor: 'evaluating' stamp: 'rkrk 6/2/2010 20:47:28.979'!
isSelectorBanned

	^ SyMethodWrapper notReplicatedSelectors includes: self selector! !

!SyMethodWrapper methodsFor: 'accessing' stamp: 'SR 6/30/2010 11:52:09.928'!
storesIntoInstVar

	^ storesIntoInstVar! !

!SyMethodWrapper methodsFor: 'evaluating' stamp: 'SR 6/30/2010 11:56:04.856'!
valueWithReceiver: anObject arguments: args

	| result tag |
	(tag := self instrumentor shouldPublishMethodCalls) ifTrue: [
		self instrumentor shouldPublishMethodCalls: false.
		self class setTlsValue: false].
	
	self class setTlsValue: (self class getTlsValue or: [self storesIntoInstVar]).
	result := self clientMethod
		valueWithReceiver: anObject
		arguments: args.
	
	tag ifTrue: [
		self instrumentor shouldPublishMethodCalls: true.
		(self isSelectorBanned not and: [instrumentor notNil]) ifTrue: [
			instrumentor
				methodCalled: (self selector)
				on: anObject
				with: args
				hasSideEffect: self class getTlsValue]].
	^ result! !

TestCase subclass: #SyAddressBookTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-AddressBook-Test'!

!SyAddressBookTest methodsFor: 'running' stamp: 'rkrk 6/21/2010 01:35:05.829'!
setUp

	super setUp.
	sut := SyAddressBook new.! !

!SyAddressBookTest methodsFor: 'tests' stamp: 'rkrk 6/21/2010 01:34:51.677'!
test01CreateAddressBookAndAddPerson

	sut createAndAddPerson: 'Foo' lastName: 'Bar'.
	self assert: sut persons notEmpty.
	self assert: 'Bar' equals: sut persons first surname.! !

!SyAddressBookTest methodsFor: 'tests' stamp: 'rkrk 6/21/2010 01:35:22.691'!
test02AddFriend

	sut createAndAddPerson: 'Foo' lastName: 'Bar'.
	sut createAndAddPerson: 'Bar' lastName: 'Baz'.
	sut personListIndex: 1.
	[sut addFriend] valueSupplyingAnswers: { {'*name*'. 'Bar Baz'}}.
	self assert: sut selectedPerson friends notEmpty.! !

!SyAddressBookTest methodsFor: 'tests' stamp: 'rkrk 6/21/2010 01:35:26.024'!
test03EditBirthday

	sut createAndAddPerson: 'Foo' lastName: 'Bar'.
	sut personListIndex: 1.
	[sut editBirthday] valueSupplyingAnswers: { {'*birthday*'. '20 10 1985'}}.
	self assert: (Date year: 1985 month: 10 day: 20) equals: sut selectedPerson birthday.! !

!SyAddressBookTest methodsFor: 'tests' stamp: 'rkrk 6/21/2010 01:35:29.203'!
test04EditAddress

	sut createAndAddPerson: 'Foo' lastName: 'Bar'.
	sut personListIndex: 1.
	[sut editAddress] valueSupplyingAnswers: {
		{'*street*'. 'Prof.-Dr.-Helmert Str.'}.
		{'*number*'. '2-3'}.
		{'*postal*'. '14482'}.
		{'*town*'. 'Potsdam'}}.
	self assert: 'Potsdam' equals: sut selectedPerson address town.! !

TestCase subclass: #SyReferenceMappingStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

SyReferenceMappingStreamTest class
	instanceVariableNames: 'sut'!

SyReferenceMappingStreamTest class
	instanceVariableNames: 'sut'!

!SyReferenceMappingStreamTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:35:20.283'!
test01UseBlockWhenSerializing

	| result sut |
	sut := SyReferenceMappingStream mapping: (SyReferenceMapping foreward: [:obj | 2]).
	sut nextPut: 1.
	sut reset.
	result := sut next.
	self assert: 2 equals: result.! !

!SyReferenceMappingStreamTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:35:46.328'!
test02CyclicMapping

	| result sut person |
	sut := SyReferenceMappingStream mapping: SyReferenceMapping identity.
	person := Person givenName: 'Peter' surname: 'Lustig'.
	person specialFriend: person.
	sut nextPut: person.
	sut reset.
	result := sut next.
	self assert: result == result specialFriend.
! !

!SyReferenceMappingStreamTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:34:38.361'!
test03ComplexMapping

	| result person1 person2 sut |
	sut := SyReferenceMappingStream mapping: (SyReferenceMapping foreward: [:obj |
		((obj isKindOf: Person) and: [obj givenName = 'Fritz'])
			ifTrue: [23]
			ifFalse: [obj]]).
	person1 := Person givenName: 'Peter' surname: 'Lustig'.
	person2 := Person givenName: 'Fritz' surname: 'Fuchs'.
	person1 specialFriend: person2.
	sut nextPut: person1.
	sut reset.
	result := sut next.
	self assert: 23 == result specialFriend.
! !

TestCase subclass: #SyTestCase
	instanceVariableNames: 'syClients'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

SyTestCase subclass: #SyClientTestCase
	instanceVariableNames: 'server sut obj1Server obj2Server obj1UUID obj2UUID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyClientTestCase class methodsFor: 'as yet unclassified' stamp: 'SR 6/14/2010 18:56:49.554'!
defaultPort

	^ 22701! !

!SyClientTestCase methodsFor: 'running' stamp: 'SR 6/14/2010 18:50:46.508'!
setUp

	super setUp.
	server := SyServer new.
	obj1Server := Person givenName: 'Micha' surname: 'Test'.
	obj2Server := Person givenName: 'Christoph' surname: 'Muster'.
	obj1UUID := (server repository register: obj1Server) uuid.
	obj2UUID := (server repository register: obj2Server) uuid.
	server start.! !

!SyClientTestCase methodsFor: 'running' stamp: 'SR 6/14/2010 18:54:07.722'!
tearDown

	| errBlock |
	super tearDown.
	errBlock := [:e |
		Transcript cr;
			show: 'Error in tearDown of ' , self class , '>>#' , self selector;
			show: e].
	
	[server stop] on: Error do: errBlock.
	[server release] on: Error do: errBlock.
	server repository clear.! !

SyClientTestCase subclass: #SyClientTests
	instanceVariableNames: 'spy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyClientTests methodsFor: 'running' stamp: 'mt 6/23/2010 16:07:15.519'!
setUp

	super setUp.
	spy := SignalSpy onSender: server signal: #commandExecuted:.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 6/2/2010 22:39:21.285'!
test01ConnectDisconnect

	sut := self createAndConnectClient.
	self assert: sut isConnected.
	sut disconnect.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 6/14/2010 01:10:54.352'!
test02GetObjects

	sut := self createAndConnectClient.
	self assert: sut isConnected.	
	self assert: (sut repository size = 2).
	self assert: (sut repository all contains: [:o | o = obj1Server]).
	self assert: (sut repository all contains: [:o | o = obj2Server]).! !

!SyClientTests methodsFor: 'testing' stamp: 'SR 6/29/2010 11:38:04.419'!
test03ServerAppliesClientOperation

	| objClient |
	sut := self createAndConnectClient.
	objClient := sut repository resolve: obj1UUID.
	objClient givenName: 'Hans'.
	
	self waitFor: SyApplyCommand.
	World doOneCycle.
	
	self assert: 'Hans' equals: obj1Server givenName.! !

!SyClientTests methodsFor: 'testing' stamp: 'SR 6/29/2010 11:42:33.71'!
test04OtherClientAppliesClientOperation

	| objClient1 objClient2 client1 client2 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	objClient1 := client1 repository resolve: obj1UUID.
	objClient2 := client2 repository resolve: obj1UUID.
	
	objClient1 givenName: 'Hans'.
	
	self wait: 2.
	World doOneCycle.
	
	self assert: 'Hans' equals: objClient2 givenName.! !

!SyClientTests methodsFor: 'testing' stamp: 'mt 6/15/2010 16:01:41.085'!
test05VersionsAfterListCommand

	| obj ro roAtClient |
	"Register a new object and perform an operation."
	obj := Person givenName: 'Peter' surname: 'Klaus'.
	ro := server repository register: obj.
	(SyApplyCommand receiver: ro selector: #givenName: arguments: #(Micha))
		execute: server repository.

	"Create client, fetch object with list command and verify the version."
	sut := self createAndConnectClient.
	roAtClient := sut repository registeredObjectForUUID: ro uuid.

	self
		assert: 1 equals: roAtClient versionOffset;
		assert: 1 equals: roAtClient version.! !

!SyClientTests methodsFor: 'testing' stamp: 'mt 6/15/2010 16:01:41.155'!
test06BadVersionNotReplicated

	| objClient1 objClient2 client1 client2 regObjClient1 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	objClient1 := client1 repository resolve: obj1UUID.
	objClient2 := client2 repository resolve: obj1UUID.
	
	regObjClient1 := client1 repository registeredObjectForUUID: obj1UUID.
	regObjClient1 versionOffset: 999. "Manipulate version."
	
	Transcript cr; show: 'SyClientTests>>#test06BadVersionNotReplicated - Client1 = ', client1 identityHash asString.
	
	
	"spy := SignalSpy onSender: server signal: #connectionsChanged."
	objClient1 givenName: 'Hans'.
	
	"spy waitForNextSignal." "Client 1 disconnected."
	"spy waitForNextSignal. ""Client 1 connected again."
	
	self wait: 2.
	
	self assert: 'Micha' equals: objClient2 givenName.
	
	"Check transscript for refused-message."
	Transcript cr; show: 'SyClientTests>>#test06BadVersionNotReplicated - Client1 = ', client1 identityHash asString, ' (rebooted)'.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 7/12/2010 13:09:40.128'!
test07DeferSends


	| client objClient |
	client :=  self createAndConnectClient.
	client deferSends.
	objClient := client repository resolve: obj1UUID.
	objClient givenName: 'Hans'.
	self wait: 1.
	self assert: 1 equals: client commandsNotYetSend size.
	self assert: 'Micha' equals: obj1Server givenName.
	client dontDeferSends.
	self wait: 1.
	self assert: 0 equals: client commandsNotYetSend size.
	self assert: 'Hans' equals: obj1Server givenName.! !

!SyClientTests methodsFor: 'testing' stamp: 'rkrk 7/12/2010 13:05:13.783'!
test08ServerStateIsUsedOnConflict

	"Acceptance test for Story 4 Task 2"

	| client1 client2 objClient1 objClient2 |
	client1 := self createAndConnectClient.
	client2 := self createAndConnectClient.
	objClient1 := client1 repository resolve: obj1UUID.
	objClient2 := client2 repository resolve: obj1UUID.
	
	client1 deferSends.
	objClient1 givenName: 'Hans'.	
	self wait: 1.
	self assert: 'Micha' equals: objClient2 givenName.

	objClient2 givenName: 'Fritz'. "conflict!!"
	self wait: 1.
	self assert: 'Fritz' equals: obj1Server givenName.
	self assert: 'Fritz' equals: objClient1 givenName.
	self assert: 0 equals: client1 commandsNotYetSend size. "clean up"! !

!SyClientTests methodsFor: 'tests' stamp: 'SR 6/29/2010 11:43:10.928'!
test09PersonWithBidirectionalSpecialFriend

	| client1 client2 obj1Client1 obj2Client1 obj1Client2 obj2Client2 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj1Client1 := client1 repository resolve: obj1UUID.
	obj2Client1 := client1 repository resolve: obj2UUID.
	
	obj1Client1 bidirectionalSpecialFriend: obj2Client1.
	
	obj1Client2 := client2 repository resolve: obj1UUID.
	obj2Client2 := client2 repository resolve: obj2UUID.
	
	self wait: 2.
	World doOneCycle.
	
	self
		assert: obj1Client1 specialFriend == obj2Client1;
		assert: obj2Client1 specialFriend == obj1Client1;
		assert: obj1Client2 specialFriend == obj2Client2;
		assert: obj2Client2 specialFriend == obj1Client2.! !

!SyClientTests methodsFor: 'tests' stamp: 'mt 6/19/2010 17:19:09.686'!
test10OperationWithNestedMethods

	| client1 client2 obj1Client1 obj2Client1 obj1Client2 obj2Client2 obj1Client2OpCount obj2Client2OpCount |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj1Client1 := client1 repository resolve: obj1UUID.
	obj2Client1 := client1 repository resolve: obj2UUID.
	obj1Client2 := client2 repository resolve: obj1UUID.
	obj2Client2 := client2 repository resolve: obj2UUID.	

	obj1Client2OpCount := (client2 repository registeredObjectForDomainObject: obj1Client2) operations size.
	obj2Client2OpCount := (client2 repository registeredObjectForDomainObject: obj2Client2) operations size.
	
	obj1Client1 bidirectionalSpecialFriend: obj2Client1.
	
	self wait: 2.
	self
		assert: obj1Client2OpCount+1 equals: (client2 repository registeredObjectForDomainObject: obj1Client2) operations size;
		assert: obj2Client2OpCount equals: (client2 repository registeredObjectForDomainObject: obj2Client2) operations size.! !

!SyClientTests methodsFor: 'tests' stamp: 'SR 6/22/2010 17:03:10.588'!
test11RootObjectAfterClientsConnected

	| client1 client2 obj3 obj3UUID |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj3 := Person givenName: 'Alex' surname: 'Muster'.
	client1 repository rootObject: obj3.
	
	obj3UUID := (client1 repository registeredObjectForDomainObject: obj3) uuid.

	self wait: 2.
	
	self
		assert: client2 repository rootObject notNil;
		assert: (client2 repository registeredObjectForDomainObject: client2 repository rootObject) uuid = obj3UUID.
! !

!SyClientTests methodsFor: 'tests' stamp: 'SR 6/29/2010 15:38:43.519'!
test12ApplyCommandsInGuiProcess

	| client1 obj1Client1 obj1Client2 client2 methodWrapper |
	client1 := self createAndConnectClient.
	client2 := self createAndConnectClient.
	methodWrapper := (SyGUIProcessTestMethodWrapper on: #perform:withArguments: inClass: Object) install.
	
	obj1Client1 := client1 repository resolve: obj1UUID.
	obj1Client2 := client2 repository resolve: obj1UUID.
	
	obj1Client1 givenName: 'Hans'.
	
	self wait: 2.
	World doOneCycle.
	
	methodWrapper uninstall.
	self
		assert: 'Hans' equals: obj1Client2 givenName;
		assert: methodWrapper isGuiProcess.

! !

!SyClientTests methodsFor: 'support' stamp: 'mt 6/23/2010 16:08:36.111'!
waitFor: aCommandClass

	spy waitForNextSignalSatisfying: [:signal |
		signal second includes: aCommandClass].! !

SyClientTestCase subclass: #SyObjectReferenceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'SR 6/14/2010 19:03:11.274'!
test01PersonAddsSingleFriend

	| client obj1Client obj2Client |
	obj1Server specialFriend: obj2Server.
	client :=  self createAndConnectClient.
	obj1Client := client repository resolve: obj1UUID.
	obj2Client := client repository resolve: obj2UUID.
	self assert: obj1Client specialFriend == obj2Client.! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'SR 6/14/2010 20:01:02.561'!
test02PersonWithFriendCollection

	| client obj1Client obj2Client obj3Server obj3UUID obj3Client |
	obj3Server := Person givenName: 'Robert' surname: 'Tester'.
	obj3Server
		addFriend: obj1Server;
		addFriend: obj2Server.
	obj3UUID := (server repository register: obj3Server) uuid.
	
	client :=  self createAndConnectClient.
	obj1Client := client repository resolve: obj1UUID.
	obj2Client := client repository resolve: obj2UUID.
	obj3Client := client repository resolve: obj3UUID.
	self assert: obj3Client friends size = 2.
	self assert: obj3Client friends first == obj1Client.
	self assert: obj3Client friends second == obj2Client.! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'SR 6/14/2010 20:00:48.793'!
test03PersonWithCyclicFriendCollection

	| client obj1Client obj2Client |
	obj1Server addFriend: obj2Server.
	obj2Server addFriend: obj1Server.
		
	client :=  self createAndConnectClient.
	obj1Client := client repository resolve: obj1UUID.
	obj2Client := client repository resolve: obj2UUID.
	self assert: obj1Client friends first == obj2Client.
	self assert: obj2Client friends first == obj1Client.! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'rkrk 7/12/2010 13:10:11.615'!
test04OperationWithComplexParameter

	| client1 client2 obj1Client1 obj2Client1 obj1Client2 obj2Client2 |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj1Client1 := client1 repository resolve: obj1UUID.
	obj2Client1 := client1 repository resolve: obj2UUID.
	
	obj1Client1 specialFriend: obj2Client1.
	
	obj1Client2 := client2 repository resolve: obj1UUID.
	obj2Client2 := client2 repository resolve: obj2UUID.
	
	self wait: 2.
	
	self assert: obj1Client2 specialFriend == obj2Client2! !

!SyObjectReferenceTests methodsFor: 'tests' stamp: 'rkrk 7/12/2010 13:10:06.476'!
test05OperationWithUnregisteredEntity

	| client1 client2 obj1Client1 obj1Client2 obj3UUID |
	client1 :=  self createAndConnectClient.
	client2 := self createAndConnectClient.

	obj1Client1 := client1 repository resolve: obj1UUID.
	
	obj1Client1 specialFriend: (Person givenName: 'Marcel' surname: 'Muster').
	
	obj1Client2 := client2 repository resolve: obj1UUID.
	
	self wait: 2.
	
	obj3UUID := (client1 repository registeredObjectForDomainObject: obj1Client1 specialFriend) uuid.
	self
		assert: (obj1Client1 specialFriend == (client1 repository resolve: obj3UUID));
		assert: obj1Client2 specialFriend notNil;
		assert: (obj1Client2 specialFriend == (client2 repository resolve: obj3UUID)).! !

SyTestCase subclass: #SyCommandsTest
	instanceVariableNames: 'repo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyCommandsTest methodsFor: 'running' stamp: 'rkrk 6/10/2010 08:50:02.305'!
setUp

	super setUp.
	repo := SyRepository new.! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:24:44.145'!
test01CreateApplyCommand

	| sut obj regObj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C).

	self
		assert: #(C) equals: sut arguments;
		assert: regObj uuidString equals: sut receiverUUIDString;
		assert: #givenName: equals: sut selector.! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 7/10/2010 12:45:50.251'!
test02ExecuteApplyCommand

	| sut obj regObj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C).
	sut execute: repo.
	
	"Execution happens in UI process."
	WorldState deferredUIMessages next value.
	
	self assert: 'C' equals: obj givenName.! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:24:59.884'!
test03ApplyCommandVersion

	| sut applyCommand regObj obj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	applyCommand := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C).
		
	applyCommand execute: repo.

	"Create the real test object for this test."
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(D).

	self
		assert: 0 equals: applyCommand expectedVersion;
		assert: 1 equals: sut expectedVersion.! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:25:07.291'!
test04ApplyCommandVersionMismatch

	| sut regObj obj |
	obj := Person givenName: 'A' surname: 'B'.
	regObj := repo register: obj.
	
	sut := (SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C))
		expectedVersion: 999. "A new object should have 0 and not 999."
		
	self deny: (sut execute: repo).! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 6/12/2010 19:12:54.003'!
test05ApplyCommandMissingObject

	| sut |
	sut := SyApplyCommand new
		receiverUUIDString: UUID new asString.
		
	self deny: (sut execute: repo).! !

!SyCommandsTest methodsFor: 'tests' stamp: 'mt 6/15/2010 15:25:17.847'!
test06ArgumentSerialisationTest

	| sut o1 regObj |
	o1 := Person givenName: 'Max' surname: 'Muster'.
	regObj := repo register: o1.
	
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: #(C). 
	
	self assert: sut arguments = #(C).
	
	sut := SyApplyCommand
		receiver: regObj
		selector: #givenName:
		arguments: {o1.}.
	
	self assert: sut arguments first == o1.! !

SyTestCase subclass: #SyCommunicationModuleTest
	instanceVariableNames: 'tcpServer openClientSockets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyCommunicationModuleTest class methodsFor: 'helper' stamp: 'rkrk 5/14/2010 17:02'!
closeAllSockets

	Socket registry keys
		select: [:ea | ea isWaitingForConnection or: [ea isOtherEndClosed] or: [ea isConnected]]
		thenDo: [:ea | ea close].! !

!SyCommunicationModuleTest class methodsFor: 'constants' stamp: 'rkrk 5/14/2010 14:24'!
defaultPort

	^ 22701! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 6/6/2010 14:12:36.628'!
connectTCPClientToServer

	^ self connectTCPClientToServer: true! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 6/6/2010 14:17:35.823'!
connectTCPClientToServer: shouldBeBlocking

	| spy tcpSocket |
	tcpServer ifNotNilDo: [:server| spy := SignalSpy onSender: tcpServer signal: #connectionsChanged].
	
	tcpSocket := SyTcpSocket
		connectToHost: '127.0.0.1'
		port: self class defaultPort.
	
	(shouldBeBlocking and: [spy notNil]) ifTrue: [spy waitForNextSignal].
	openClientSockets add: tcpSocket.
	
	^ tcpSocket.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'mt 6/6/2010 14:21:46.429'!
disconnectTCPClientsFromServer

	| spy |
	tcpServer ifNotNilDo: [:server| spy := SignalSpy onSender: tcpServer signal: #connectionsChanged].
	openClientSockets do: [:ea | 
		ea isConnected ifTrue: [
			ea close.
			spy ifNotNilDo: [:s| s waitForNextSignal]]].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'SR 6/3/2010 14:06:07.673'!
setUp

	super setUp.
	openClientSockets := OrderedCollection new.
	Transcript cr; show: 'start '; show: self selector.! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'SR 6/3/2010 14:11:29.696'!
startTcpServer

	tcpServer ifNil: [
		tcpServer := SyTcpServer new].
	tcpServer isListening
		ifFalse: [tcpServer listenOn: self class defaultPort].! !

!SyCommunicationModuleTest methodsFor: 'support' stamp: 'rkrk 5/26/2010 15:48:10.549'!
stopTcpServer

	tcpServer ifNotNil: [tcpServer close].! !

!SyCommunicationModuleTest methodsFor: 'running' stamp: 'rkrk 5/14/2010 18:15'!
tearDown

	super tearDown.
	Transcript cr; show: 'end '; show: self selector.
	[self
		disconnectTCPClientsFromServer;
		stopTcpServer
	] on: Error do: [:e | Transcript cr; show: 'Error in tearDown'; print: e].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:34.851'!
test01TcpServerStartup

	| sut |
	sut := SyTcpServer new.
	
	self deny: sut isListening.
	
	[sut listenOn: self class defaultPort.
	self
		assert: sut isListening;
		assert: self class defaultPort equals: sut port;
		assert: sut connections isEmpty.
	] ensure: [sut close].! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'rkrk 5/28/2010 00:50:03.209'!
test02TcpServerShutdown
	
	self
		startTcpServer;
		assert: tcpServer isListening;
		stopTcpServer;
		deny: tcpServer isListening;
		assert: tcpServer connections isEmpty;
		assert: tcpServer connectionProcesses isEmpty;
		assert: (Socket registry keys noneSatisfy: [:socket | socket isWaitingForConnection]).! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'mt 6/6/2010 14:12:08.38'!
test03FailingTcpSocketConnection

	"try to connect to a server. This should either throw a ConnectionTimedOut error.
	Since we currently cannot control the timeout period of sockets and the default of 
	[Socket standardTimeout] = 45 is used we end the test earlier and just assume
	that the connection can't be established."
	<timeout: 3> "1s more than needed"
	| connectionFailed connectReturned connectProcess |
	connectionFailed := false.
	connectReturned := false.
	connectProcess := [
		[self connectTCPClientToServer: false. connectReturned := true]
			on: ConnectionTimedOut
			do: [connectionFailed := true]] fork.
	self wait: 2. "seconds"
	connectProcess terminate.
	connectionFailed ifTrue: [^self].
	connectReturned ifTrue: [^self]. "assume it works"
	self
		assert: false
		description: '#connectTCPClientToServer was successful although no server was started!!'.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'mt 6/6/2010 14:18:50.298'!
test04TcpSocketConnection

	| tcpSocket |
	self startTcpServer.
	tcpSocket := self connectTCPClientToServer.
	self
		assert: tcpSocket isConnected description: 'tcp socket not connected';
		assert: 1 equals: tcpServer connectionProcesses size.! !

!SyCommunicationModuleTest methodsFor: 'tests' stamp: 'mt 6/6/2010 14:12:51.446'!
test05TcpServerIncomingConnections

	self
		startTcpServer;
		assert: tcpServer connections isEmpty;
		connectTCPClientToServer;
		assert: tcpServer connections size = 1;
		connectTCPClientToServer;
		assert: tcpServer connections size = 2;
		disconnectTCPClientsFromServer;
		assert: tcpServer connections isEmpty.! !

SyTestCase subclass: #SyProcessBugTest
	instanceVariableNames: 'process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyProcessBugTest methodsFor: 'as yet unclassified' stamp: 'mt 6/9/2010 15:56:30.19'!
tearDown

	super tearDown.
	process ifNotNilDo: [:p | p terminate]! !

!SyProcessBugTest methodsFor: 'as yet unclassified' stamp: 'mt 6/9/2010 15:56:54.556'!
test01Termination

	process := [[1+1] repeat ] sqForkAt: 35.
	process suspend.
	process terminate.
	
	self assert: process isTerminated.! !

!SyProcessBugTest methodsFor: 'as yet unclassified' stamp: 'mt 6/9/2010 16:00:08.618'!
test02FailedTermination

	process := [[1+1] repeat ] forkAt: 35.
	process suspend.
	process terminate.
	
	self deny: process isTerminated.
	
	[process priority: 60; resume.
	Processor yield.
	process terminate] forkAt: 60.

	self assert: process isTerminated.! !

SyTestCase subclass: #SyRepositoryTests
	instanceVariableNames: 'sut o1 o2 applyCommand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyRepositoryTests methodsFor: 'running' stamp: 'SR 6/1/2010 09:39:19.875'!
setUp

	super setUp.
	
	sut := SyRepository new.
	o1 := Person givenName: 'Micha' surname: 'Test'.
	o2 := Person givenName: 'Christoph' surname: 'Muster'.! !

!SyRepositoryTests methodsFor: 'running' stamp: 'mt 6/19/2010 14:59:00.996'!
tearDown

	"Unregister method wrappers."
	sut shouldCreateCommands: false.
	applyCommand := nil.
	
	^ super tearDown ! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/1/2010 09:42:02.101'!
test01UnRegisterObject

	self assert: sut isEmpty.
	sut register: o1.
	self assert: sut all size = 1.
	sut unregister: o1.
	self assert: sut isEmpty.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 6/19/2010 14:21:18.382'!
test02DoubleRegistration

	self assert: sut isEmpty.
	sut register: o1.
	self assert: sut all size = 1.
	
	self
		should: [sut register: o1]
		raise: SyAlreadyRegisteredException.
! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 6/19/2010 14:59:45.002'!
test03UnWrapObject

	self deny: (o1 class methodDict values first isMwMethodWrapper).
	sut shouldCreateCommands: true.
	sut dontCreateCommandsDuring: [
		sut register: o1.
		self deny: (o1 class methodDict values first isMwMethodWrapper)].
	self assert: (o1 class methodDict values first isMwMethodWrapper).
	sut unregister: o1.
	self deny: (o1 class methodDict values first isMwMethodWrapper).! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 6/19/2010 14:59:01.071'!
test04ApplyCommandCreation

	| ro1 |
	sut shouldCreateCommands: true.
	ro1 := sut register: o1.
	sut addDependent: self.
	
	o1 givenName: 'Peter'.
	self
		assert: ro1 uuid equals: applyCommand receiverUUID;
		assert: #givenName: equals: applyCommand selector.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'mt 6/19/2010 14:59:00.904'!
test05OperationStackTest

	| ro1 |
	sut shouldCreateCommands: true.
	ro1 := sut register: o1.
	sut addDependent: self. "Catch apply commands in this object."
	
	self assert: ro1 operations isEmpty.
	
	o1 givenName: 'Siegbert'. "Create apply command."
	
	self assert: 0 equals: ro1 version.
		
	self
		assert: (applyCommand execute: sut); "Execute command on repository."
		assert: 1 equals: ro1 version;
		assert: ro1 version equals: ro1 operations size;
		assert: #givenName: equals: ro1 operations last selector;
		assert: {'Siegbert'} equals: ro1 operations last arguments.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/14/2010 18:43:17.76'!
test06RootObjectTest

	self assert: sut rootObject = nil.
	sut rootObject: o1.
	self assert: sut rootObject = o1	! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/30/2010 11:19:37.091'!
test07CompiledMethodInstVarStoreTest

	self
		assert: (Person>>#givenName:) hasInstVarStore;
		assert: (SyRepository>>#initialize) hasInstVarStore;
		deny: (Person>>#givenName) hasInstVarStore;
		deny: (SyRepository>>#isEmpty) hasInstVarStore.! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/30/2010 12:02:28.433'!
test08DoNotCreateApplyCommandsForReadingMessages

	"Enable deeper call-stacks"
	o1 specialFriend: o2.
	
	"Prepare repo"
	sut shouldCreateCommands: true.
	sut register: o2.
	sut register: o1.
	sut addDependent: self.

	applyCommand := nil.
	
	"Call a couple of read-only functions"
	o1 givenName.
	self assert: applyCommand isNil.
	
	o1 specialFriend givenName.
	self assert: applyCommand isNil.
! !

!SyRepositoryTests methodsFor: 'testing' stamp: 'SR 6/30/2010 12:02:20.226'!
test09DoCreateApplyCommandsForWritingMessages

	"Enable deeper call-stacks"
	o1 specialFriend: o2.
	
	"Prepare repo"
	sut shouldCreateCommands: true.
	sut register: o2.
	sut register: o1.
	sut addDependent: self.

	applyCommand := nil.
	
	"Call a couple of read-only functions"
	o1 givenName: 'Micha'.
	self assert: applyCommand notNil.

	o1 specialFriend givenName: 'Tina'.
	self assert: applyCommand notNil.	

! !

!SyRepositoryTests methodsFor: 'support' stamp: 'SR 6/1/2010 10:22:24.996'!
update: anAspect with: aParameter

	(anAspect = #operation) ifTrue: [ applyCommand := aParameter ].
	super update: anAspect with: aParameter.! !

SyTestCase subclass: #SyServerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SyServerTest methodsFor: 'support' stamp: 'mt 6/19/2010 16:30:20.172'!
collectInstanceNumbers

	^ {
		#SyMethodWrapper -> SyMethodWrapper allInstances size.
		#SyClassInstrumentor -> SyClassInstrumentor allInstances size.
		#SyRepository -> SyRepository allInstances size.
		#SyServer -> SyServer allInstances size.
		#SyProtocolProcessor -> SyProtocolProcessor allInstances size.
		#Process -> Process allInstances size.
	}! !

!SyServerTest methodsFor: 'tests' stamp: 'mt 6/19/2010 16:49:06.138'!
test01Finalization
	
	| server num numAfter |
	num := self collectInstanceNumbers.
	
	server := SyServer new start stop.
	server := nil.
	
	Processor yield.
	Smalltalk garbageCollect.
	
	numAfter := self collectInstanceNumbers.
	
	self assert: num equals: numAfter.! !

!SyServerTest methodsFor: 'tests' stamp: 'mt 6/19/2010 16:37:36.359'!
test02FinalizationWithWrappers
	
	| server num numAfter |
	num := self collectInstanceNumbers.
	
	server := SyServer new start.
	server repository register: (Person givenName: 'Stefan' surname: 'Muster').
	server repository shouldCreateCommands: true.
	server stop.
	server := nil.
	
	Processor yield.
	Smalltalk garbageCollect.
	
	numAfter := self collectInstanceNumbers.
	self assert: num equals: numAfter.! !

SyTestCase subclass: #SySimpleProtocolProcessorTest
	instanceVariableNames: 'sut o1 stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySimpleProtocolProcessorTest methodsFor: 'support' stamp: 'mt 5/30/2010 21:10:42.257'!
clearStream

	stream := ReadWriteStream on: ''.! !

!SySimpleProtocolProcessorTest methodsFor: 'support' stamp: 'mt 5/30/2010 21:18:41.14'!
resetStream

	stream reset.! !

!SySimpleProtocolProcessorTest methodsFor: 'running' stamp: 'mt 5/30/2010 20:46:11.522'!
setUp

	super setUp.
	sut := SySimpleProtocolProcessor new.
	o1 := Dictionary newFrom: {
		#tag -> 'uuid'.
		#value -> UUID new asString}.
	self clearStream.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'mt 6/15/2010 15:36:59.508'!
test01Serialization

	| serialized deserialized |
	sut objectMapping: SyReferenceMapping identity.
	serialized := sut serialize: o1 withMapping: false.
	deserialized := sut deserialize: serialized withMapping: false.
	self assert: deserialized = o1.! !

!SySimpleProtocolProcessorTest methodsFor: 'testing' stamp: 'SR 6/14/2010 19:36:16.865'!
test02SendingReceivingCommands

	| command process result nextCommand |

	command := SyQuitCommand new.
			
	process := [
		result := sut sendCommandBlocking: command on: stream.
	] forkAt: 60.
	
	self resetStream.
	sut processDataFrom: stream.
	
	nextCommand := sut nextCommand.
	self assert: {0. command. stream.} equals: nextCommand.
	
	self clearStream.
	sut 
		sendCommandResult: nextCommand second
		with: nextCommand first
		on: stream.
	
	self resetStream.
	sut processDataFrom: stream.
	
	Processor yield. "Let the result variable be set."

	self
		assert: (nextCommand second) equals: result;
		assert: process isTerminated.! !

SyTestCase subclass: #SySocketBugTest
	instanceVariableNames: 's1 s2 s3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSync-Tests'!

!SySocketBugTest methodsFor: 'running' stamp: 'rkrk 5/29/2010 11:56:47.535'!
tearDown

	super tearDown.
	s1 closeAndDestroy.
	s2 closeAndDestroy.
	s3 closeAndDestroy.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 12:00:17.802'!
test01AutoDisconnection

	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345.
	s3 := s2 connectToHostNamed: 'localhost' port:  12345.
	s1 waitForConnectionFor: 5.
	s2 waitForConnectionFor: 5.
	self
		assert: s1 isConnected;
		assert: s2 isConnected;
		assert: s3 == s2.

	s2 closeAndDestroy.
	s1 forceStatusUpdate.
		
	self
		deny: s2 isConnected;
		deny: s1 isConnected.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 12:00:23.284'!
test02AutoDisconnectionWithServer

	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345 backlogSize: 4.
	s2 connectToHostNamed: 'localhost' port:  12345.
	s3 := s1 waitForAcceptFor: 5.
	s2 waitForConnectionFor: 5.
	
	self
		deny: s1 isConnected;
		assert: s2 isConnected;
		assert: s3 isConnected.

	s2 closeAndDestroy.
	s3 forceStatusUpdate.
		
	self
		deny: s1 isConnected;
		deny: s2 isConnected;
		deny: s3 isConnected.! !

!SySocketBugTest methodsFor: 'testing' stamp: 'mt 5/31/2010 13:37:50.642'!
test03StreamWorkaround
	"Check whether the workaround discards no data unexpectedly."

	| stream1 stream2 |
	
	s1 := Socket newTCP.
	s2 := Socket newTCP.
	s1 listenOn: 12345.
	s3 := s2 connectToHostNamed: 'localhost' port:  12345.
	s1 waitForConnectionFor: 5.
	s2 waitForConnectionFor: 5.
	
	stream1 := SyTcpSocket on: s1.
	stream2 := SyTcpSocket on: s2.
	
	stream1 nextPutAll: 'Hello!!'.
	stream2 isConnected. "This contains the workaround."
	
	self assert: 'Hello' equals: (stream2 upToAll: '!!').
! !

!SyTestCase methodsFor: 'support' stamp: 'rkrk 6/2/2010 22:35:45.655'!
createAndConnectClient

	| cl |
	cl := SyClient new
		connectToHostNamed: 'localhost'
		port: self class defaultPort.
	syClients add: cl.
	^ cl.! !

!SyTestCase methodsFor: 'support' stamp: 'mt 7/12/2010 13:06:19.857'!
performDeferredUIMessages

	[WorldState deferredUIMessages isEmpty]
		whileFalse: [WorldState deferredUIMessages next value].! !

!SyTestCase methodsFor: 'running' stamp: 'rkrk 6/2/2010 22:36:46.804'!
setUp

	super setUp.
	syClients := OrderedCollection new.! !

!SyTestCase methodsFor: 'running' stamp: 'rkrk 6/2/2010 22:38:01.013'!
tearDown

	super tearDown.
	syClients do: [:ea | ea disconnect].! !

!SyTestCase methodsFor: 'support' stamp: 'rkrk 7/12/2010 13:10:39.811'!
wait: seconds

	(Delay forSeconds: seconds) wait.
	self performDeferredUIMessages. "UI process handles command execution"! !

!Process methodsFor: '*SqSync' stamp: 'rkrk 6/13/2010 23:42:16.755'!
isNilOrTerminated

	^ self isTerminated! !
